//
//	The 123SQL Engine Written by Dzinleski Jasenko May,2005
//		Copyright (C) 2005-2007 Jasenko Dzinleski 
//
//	This source and the 123SQL Engine apply to GNU General Public License. 
//
//		This program is free software; you can redistribute it
//	and/or modify it under the terms of the GNU General Public License as
//	published by the Free Software Foundation; either version 2 of the
//	License, or (at your option) any later version. 
//
//	This program is distributed in the hope that it will be useful, but
//	WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
//	General Public License for more details. 
//
//	You should have received a copy of the GNU General Public License along
//	with this program; if not, write to the Free Software Foundation, Inc.,
//	51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.

//		The SQL Engine Routines

#include "t1131.cpp"
#include "c31331.cpp"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>

#define			stlen		700
#define			nstat		300
#define			nopt		256
#define			sn		30
#define			icsiz		50

#define			fnamel		36
#define			tnamel		36
#define			carrl		256
#define			nfields		50
#define			fieldlen	1024

#define			tc		10

#define			sh		8
#define			bl		128
#define			cct		512
#define			lnl		512
#define			vnaml		255

typedef struct t_trec_hd1
{
	unsigned		tnme[16];				//table name hash
	unsigned		rn[4];					//record number
	unsigned		fldn[nfields][16];			//field names array hash
	unsigned		fldtyp[nfields];			//field types array 1-char,2-int,3-long,4-unsigned,5-bool,...
	unsigned		fldpos[nfields][4];			//field positions array = record position + field length
} trec_hd1;

typedef struct t_rec_data1
{
	unsigned		fldlen[2];				//field length
	unsigned		flddata[fieldlen];			//field data 
} rec_data1;

typedef struct t_stmnt_arr 
{
	char			var[stlen];
	char			kew[stlen];
	int			opt;
	int			opti;
	int			prev;
	int			next;
} stmnt_arr;

typedef struct t_prc_arr 
{
	int prc[nstat][2];
} prc_arr;

stmnt_arr		stmnt[nstat];

FILE			*f1,*f2,*f3,*f4,*f11,*f13,*f15;

char			f1n[fnamel]="SQLSyntax.txt";
char			f2n[fnamel]="SQLQuery.txt";
char			f3n[fnamel]="SQLKeywords.txt";
char			f4n[fnamel]="SQLInput.txt";

char			f11ns[fnamel]="123SQL_db_1.mar";
char			f13ns[fnamel]="123SQL_db_3.mar";
char			f11n[fnamel]="_db_1.mar";
char			f13n[fnamel]="_db_3.mar";
char			f11np[fnamel];
char			f13np[fnamel];
char			f15n[fnamel]="out.txt";

int			st_att_i=0,rta[sn],ri,pai;
long			st_ord_arr[nopt][2];
char			err[nopt]="";
prc_arr			pa[nstat];

char			*to="This Program is Dedicated to Nada Popstefanova and Maria,Dusica,Borce Dzinleski";

FILE			*fi1,*fi2,*fi3,*fi7,*fi9,*fi13,*fi15,*fi17;
FILE			*fi11,*fi21,*fi31,*fi71;

char			fi1n[fnamel]="iinput.txt";
char			fi2n[fnamel]="out000.txt";
char			fi3n[fnamel]="out001.txt";
char			fi7n[fnamel]="out003.txt";
char			fi11n[fnamel]="iinput.txt";
char			fi21n[fnamel]="out000.txt";
char			fi31n[fnamel]="out001.txt";
char			fi71n[fnamel]="out003.txt";

const int		cs=1000;
const int		mu=10;
const int		istrlen=9;
const int		maxr=100;
const int		nrows=50;
const int		sarows=nrows*maxr;
unsigned long		data[cs][2];

unsigned long		b[bl/2],b1[bl/2],csmh;
__int64			key;
long			keyL;
long			mL;

typedef struct dtarr1 
{
	unsigned long	ind;
	unsigned long	ref;
	int		prev;
	int		next;
} tdtarr1;

tdtarr1	outdtarr[cs+1];

int			rowlen;
			
char			message[cct]="Skopje ima kontinentalna klima 0123456789\0";
long			hmessage[cct];
int			tch[cct][2];

char			ersl[lnl];
char			result[lnl];

int			inc[512];
int			ouc[512];

char			cm[nopt],cmkw[fnamel][fnamel],cmva[fnamel][fnamel];

int			vor[fnamel][2];

char			fname[nfields][fnamel];
char			darr[nfields][fieldlen];

int			cmi,ti,bsw;

char			v1[fnamel]="table_name";
char			v2[fnamel]="column_name";
char			v3[fnamel]="...";
char			v4[fnamel]="search_conditions";

char			ref_arr[10][2][carrl];
int			ref_arr_i=0;

char			coutfn[fnamel]="qoutX.txt";
char			doutfn[fnamel]="routX.txt";

int p_strlen(char arr0[nopt])
{
	int		i,j,k;

	j=0;k=0;
	for (i=0;i<nopt;++i)
	{
		if ((int)arr0[i]!=10&&(int)arr0[i]!=13&&(int)arr0[i]!=32&&(int)arr0[i]>=1&&(int)arr0[i]<=127){++k;}else{
			if (arr0[i]=='\0'||(int)arr0[i]==10||(int)arr0[i]==13){break;}else{if (arr0[i]==' '){++j;}
			}
		}
	}
	return(nopt-(nopt-(k+j)));
}

int p_comp(char arr1[nopt],char arr2[nopt])
{
		int		i,l1,l2;
		int		rv=0;

		if ((l1=p_strlen(arr1))!=(l2=p_strlen(arr2)))
		{
			if (l1>l2)
			{
				for (i=0;i<l2;++i)
				{
					if (arr1[i]!=arr2[i])
					{
						if (arr1[i]>arr2[i]){rv=3;return(rv);}
						if (arr1[i]<arr2[i]){rv=2;return(rv);}
					}
				}
				return(i);							
			}else{
					for (i=0;i<l1;++i)
					{
						if (arr1[i]!=arr2[i])
						{
							if (arr1[i]>arr2[i]){rv=3;return(rv);}
							if (arr1[i]<arr2[i]){rv=2;return(rv);}
						}
					}	
					return(i);				
				}
		}else{
				for (i=0;i<l1;++i)
				{
					if (arr1[i]!=arr2[i])
					{
						if (arr1[i]>arr2[i]){rv=3;return(rv);}
						if (arr1[i]<arr2[i]){rv=2;return(rv);}
					}
				}
				return(1);
		}
}

int mariahash1(int ctranslate[cct][2])
{
	//__int64		i1=475996586321018299;
	//69B145F91F67DBB

	__int64			i1=0;

	i1=0xbb;
	i1|=0x7d<<8;
	i1|=0xf6<<16;
	i1|=0x91<<24;
	i1|=0x5f<<32;
	i1|=0x14<<40;
	i1|=0x9b<<48;
	i1|=0x06<<56;

	__int64			i2=957934603;
	__int64			i3=496898833;
	__int64			i4;

	unsigned long		min;
	int			index,index1;

	int			i,j,k,l;
	bool			exitF;

	
	//i4=i2*i3;
	
	b[0]=(i1&0xff000000)>>32;
	b[1]=(i1&0x00ff0000)>>24;
	b[2]=(i1&0x0000ff00)>>16;
	b[3]=(i1&0x000000ff);

	//b1[0]=(i2&0xff000000)>>32;
	//b1[1]=(i2&0x00ff0000)>>24;
	//b1[2]=(i2&0x0000ff00)>>16;
	//b1[3]=(i2&0x000000ff);

			
	//printf("%d\n",strlen(message));


	l=0;min=0xffffffff;k=-1+bl/2;j=0;
	for (i=0;i<strlen(message);++i)
	{
			
			exitF=false;
			csmh=(0xffffffff&~b1[k])&(0xffffffff&((~ctranslate[message[i]][0]<<sh)|(ctranslate[message[i]][0])));
			while(1>0)
			{
				if(min>abs(cs-b1[j])){min=abs(csmh-b1[j]);/*printf("!");*/break;}
				++j;
				if (j==bl/2)
				{
					j=0;
					--k;
					if (k==0){k=-1+bl/2;j=0;break;}
					
				}
				csmh=(0xffffffff&~b1[k])&(0xffffffff&((~ctranslate[message[i]][0]<<sh)|(ctranslate[message[i]][0])));
				//printf("%03d%01d%01d.",abs(abs(b1[j])-abs(csmh)),k,j);
				
			}
			//printf("%05d\n",min);
			hmessage[l]=min;min=csmh;
			++l;
	}

	return(l);
}

int encrypt(int mlen,int tlen)
{
	int		i,ji,jo,l,ai,bi,fbyte;

	for (i=0;i<cct;++i){tch[i][0]=i;tch[i][1]=0;}
		
	mL=mariahash1(tch);

	for(i=0;i<mL;++i){tch[i][0]=hmessage[i]%255;}

	mL=mariahash1(tch);

	keyL=0;
	for(i=0;i<mL;++i){keyL+=hmessage[i];}

	l=0;ji=0;jo=0;
	while(ji<mlen)
	{
		if (l==mL){l=0;}
		ai=inc[ji];
		for (i=0;i<(hmessage[l]^keyL)%255;++i)
		{
			++ai;
			if (ai==255+1){ai=0;}
		}
		ouc[jo]=ai;++jo;
		++l;
		++ji;
	}

	while(ji<tlen){ouc[jo]=0;++jo;++ji;}

	return(1);

}

unsigned long i915(char fn1[],char fn2[],char tname[tnamel],char fname[nfields][fnamel],unsigned ftype[nfields],char darr[nfields][fieldlen])
{

	FILE			*f1,*f2;

	trec_hd1		r0;
	rec_data1		r1[nfields];
	unsigned		fbyte;
	int			i,j,j1=0,k,index,hl,ipt1[carrl],m;			
	unsigned long		hresult;
	unsigned long		tfname[4],recno,pos,l,fl[nfields];
	unsigned long		mfname[4],mrecno,mpos;

	for(j=0;j<nfields;++j)
	{
		if(ftype[j]==0){break;}
	}
	index=j;

	for(j=0;j<16;++j)
	{
		r0.tnme[j]=0;
	}
	for(j=0;j<4;++j)
	{
		r0.rn[j]=0;
	}
	for(j=0;j<nfields;++j)
	{
		for(i=0;i<8;++i)
		{
			r0.fldn[j][i]=0;
		}
	}
	for(j=0;j<nfields;++j)
	{
		r0.fldtyp[j]=0;
	}
	for(j=0;j<nfields;++j)
	{
		fl[j]=0;
		for(i=0;i<4;++i)
		{
			r0.fldpos[j][i]=0;
		}
	}		
	for (j=0;j<nfields;++j)
	{
		r1[j].fldlen[0]=0;
		r1[j].fldlen[1]=0;
		for(i=0;i<fieldlen;++i)
		{
			r1[j].flddata[i]=0;
		}
	}
		

	for(j=0;j<tnamel;++j)
	{
		ipt1[j]=(int)tname[j];
		inc[j]=(int)tname[j];
	}

	encrypt(strlen(tname),tnamel);

	for(i=0;i<4;++i)
	{

		tfname[i]=(ouc[i*4]<<24)&0xff000000;
		tfname[i]|=(ouc[i*4+1]<<16)&0xffff0000;
		tfname[i]|=(ouc[i*4+2]<<8)&0xffffff00;
		tfname[i]|=ouc[i*4+3];

		r0.tnme[i*4]=ouc[i*4];
		r0.tnme[i*4+1]=ouc[i*4+1];
		r0.tnme[i*4+2]=ouc[i*4+2];
		r0.tnme[i*4+3]=ouc[i*4+3];

	}

	//printf("%d\n",tfname[0]);

	recno=0;
	f2=fopen(fn2,"rb");
	
	while(!feof(f2))
	{

		mfname[0]=getc(f2)<<24;mfname[0]|=getc(f2)<<16;mfname[0]|=getc(f2)<<8;mfname[0]|=getc(f2);
		mfname[1]=getc(f2)<<24;mfname[1]|=getc(f2)<<16;mfname[1]|=getc(f2)<<8;mfname[1]|=getc(f2);
		mfname[2]=getc(f2)<<24;mfname[2]|=getc(f2)<<16;mfname[2]|=getc(f2)<<8;mfname[2]|=getc(f2);
		mfname[3]=getc(f2)<<24;mfname[3]|=getc(f2)<<16;mfname[3]|=getc(f2)<<8;mfname[3]|=getc(f2);
		mrecno=getc(f2)<<24;mrecno|=getc(f2)<<16;mrecno|=getc(f2)<<8;mrecno|=getc(f2);
		mpos=getc(f2)<<24;mpos|=getc(f2)<<16;mpos|=getc(f2)<<8;mpos|=getc(f2);

		//printf("%d %d\n",mfname[0],tfname[0]);
		if ((mfname[0]==tfname[0])&&(mfname[1]==tfname[1])&&(mfname[2]==tfname[2])&&(mfname[3]==tfname[3])){recno=mrecno;}
	}
	fclose(f2);

	if (recno==0){recno=1;}else{++recno;}
	
	r0.rn[0]=(recno&0xff000000)>>24;
	r0.rn[1]=(recno&0x00ff0000)>>16;
	r0.rn[2]=(recno&0x0000ff00)>>8;
	r0.rn[3]=(recno&0x000000ff);

	f1=fopen(fn1,"ab");
	fseek(f1,0,SEEK_END);
	pos=ftell(f1);

	printf("%d %d %d\n",recno,pos,index);

	hl=20+index*16+index+index*4;

	for(i=0;i<index;++i)
	{
		for(j=0;j<tnamel;++j)
		{
			ipt1[j]=0;
		}
		for(j=0;j<fnamel;++j)
		{
			if((int)fname[i][j]>0){ipt1[j]=(int)fname[i][j];inc[j]=(int)fname[i][j];}else{break;}
		}
		//printf("%s",fname[i]);
		encrypt(strlen(fname[i]),fnamel);

		for(k=0;k<4;++k)
		{
			r0.fldn[i][k*4]=ouc[k*4];
			r0.fldn[i][k*4+1]=ouc[k*4+1];
			r0.fldn[i][k*4+2]=ouc[k*4+2];
			r0.fldn[i][k*4+3]=ouc[k*4+3];
		}

		r0.fldtyp[i]=ftype[i];

		for(j=0;j<fieldlen;++j)
		{
			if((int)darr[i][j]!=0){r1[i].flddata[j]=(int)darr[i][j];}else{break;}
		}
			
		r1[i].fldlen[0]=(j&0xff00)>>8;
		r1[i].fldlen[1]=(j&0x00ff);

		if (i==0)
		{
			fl[i]=pos+hl;
			r0.fldpos[i][0]=(fl[i]&0xff000000)>>24;
			r0.fldpos[i][1]=(fl[i]&0x00ff0000)>>16;
			r0.fldpos[i][2]=(fl[i]&0x0000ff00)>>8;
			r0.fldpos[i][3]=(fl[i]&0x000000ff);
			//printf("!%d!",fl[i]-pos);
			fl[i+1]+=j+2;
		}else{
			l=0;for(m=0;m<=i;++m){l+=fl[m];}
			r0.fldpos[i][0]=(l&0xff000000)>>24;
			r0.fldpos[i][1]=(l&0x00ff0000)>>16;
			r0.fldpos[i][2]=(l&0x0000ff00)>>8;
			r0.fldpos[i][3]=(l&0x000000ff);
			fl[i+1]=j+2;
			//printf("!%d!",l-pos);
		}
	}


	for(j=0;j<4;++j)
	{
		putc(r0.tnme[j*4],f1);
		putc(r0.tnme[1+j*4],f1);
		putc(r0.tnme[2+j*4],f1);
		putc(r0.tnme[3+j*4],f1);
	}

	putc(r0.rn[0],f1);
	putc(r0.rn[1],f1);
	putc(r0.rn[2],f1);
	putc(r0.rn[3],f1);
	
	for(j=0;j<index;++j)
	{
		for(i=0;i<4;++i)
		{
			putc(r0.fldn[j][i*4],f1);
			putc(r0.fldn[j][1+i*4],f1);
			putc(r0.fldn[j][2+i*4],f1);
			putc(r0.fldn[j][3+i*4],f1);
		
		}
	}

	for(j=0;j<index;++j)
	{
		putc(r0.fldtyp[j],f1);
	}

	for(j=0;j<index;++j)
	{
		putc(r0.fldpos[j][0],f1);
		putc(r0.fldpos[j][1],f1);
		putc(r0.fldpos[j][2],f1);
		putc(r0.fldpos[j][3],f1);
	}


	for (i=0;i<index;++i)
	{
		k=0;
		k=r1[i].fldlen[0]<<8;
		k&=0xff00;
		k|=r1[i].fldlen[1];

		//printf("%d\n",k);
		putc(r1[i].fldlen[0],f1);
		putc(r1[i].fldlen[1],f1);

		for(j=0;j<k;++j)
		{
			putc(r1[i].flddata[j],f1);
		}
	}
	fclose(f1);

	f2=fopen(fn2,"ab");

	putc((tfname[0]&0xff000000)>>24,f2);putc((tfname[0]&0x00ff0000)>>16,f2);putc((tfname[0]&0x0000ff00)>>8,f2);putc(tfname[0]&0x000000ff,f2);
	putc((tfname[1]&0xff000000)>>24,f2);putc((tfname[1]&0x00ff0000)>>16,f2);putc((tfname[1]&0x0000ff00)>>8,f2);putc(tfname[1]&0x000000ff,f2);
	putc((tfname[2]&0xff000000)>>24,f2);putc((tfname[2]&0x00ff0000)>>16,f2);putc((tfname[2]&0x0000ff00)>>8,f2);putc(tfname[2]&0x000000ff,f2);
	putc((tfname[3]&0xff000000)>>24,f2);putc((tfname[3]&0x00ff0000)>>16,f2);putc((tfname[3]&0x0000ff00)>>8,f2);putc(tfname[3]&0x000000ff,f2);
	putc((recno&0xff000000)>>24,f2);putc((recno&0x00ff0000)>>16,f2);putc((recno&0x0000ff00)>>8,f2);putc(recno&0x000000ff,f2);
	putc((pos&0xff000000)>>24,f2);putc((pos&0x00ff0000)>>16,f2);putc((pos&0x0000ff00)>>8,f2);putc(pos&0x000000ff,f2);

	fclose(f2);
	return(recno);
}

void mi915(char fn1[],char fn2[],char fn11[],int nfld, char tname[tnamel], char fname[nfields][fnamel],unsigned int ftype[nfields],int flength[nfields])
{

	FILE			*f1,*f2,*f11;

	int			i,j,k;

	long			p;
	unsigned		fbyte;
	unsigned long		recno=0;

	char			darr[nfields][fieldlen];

	f1=fopen(fn1,"rb");if(f1==NULL){f1=fopen(fn1,"wb");fclose(f1);}else{fclose(f1);}
	f2=fopen(fn2,"rb");if(f2==NULL){f2=fopen(fn2,"wb");fclose(f2);}else{fclose(f2);}

	f11=fopen(fn11,"rb");

	while(!feof(f11))
	{
		for(k=0;k<nfld;++k){for (i=0;i<fieldlen;++i){darr[k][i]='\0';}}

		k=0;i=0;fbyte=getc(f11);
		while(!feof(f11))
		{
			while(fbyte!=9){darr[k][i]=fbyte;++i;fbyte=getc(f11);}for(j=i;j<flength[k];++j){darr[k][j]=' ';}printf(" %s\n",darr[k]);++k;i=0;
			fbyte=getc(f11);
			if(fbyte==13){fbyte=getc(f11);break;}
			if(fbyte==10){break;}
		}

		if (!feof(f11)){if(i915(fn1,fn2,tname,fname,ftype,darr)==0){break;}}
	}
	fclose(f11);
}

unsigned long s915(char fn1[],char fn2[],char tname[tnamel],char fname[nfields][fnamel],unsigned ftype[nfields],char darr[nfields][fieldlen])
{

	FILE			*f1,*f2;

	trec_hd1		r0;
	rec_data1		r1[nfields];
	unsigned		fbyte;
	int			i,j,j1=0,k,index,hl,ipt1[fnamel],m;			
	unsigned long		hresult,fl[nfields],l;
	unsigned long		tfname[4],recno,pos;
	unsigned long		mfname[4],mrecno,mpos;

	for(j=0;j<nfields;++j)
	{
		if(ftype[j]==0){break;}
	}
	index=j;

	for(j=0;j<16;++j)
	{
		r0.tnme[j]=0;
	}
	for(j=0;j<4;++j)
	{
		r0.rn[j]=0;
	}
	for(j=0;j<nfields;++j)
	{
		fl[j]=0;
		for(i=0;i<16;++i)
		{
			r0.fldn[j][i]=0;
		}
	}
	for(j=0;j<nfields;++j)
	{
		r0.fldtyp[j]=0;
	}
	for(j=0;j<nfields;++j)
	{
		for(i=0;i<4;++i)
		{
			r0.fldpos[j][i]=0;
		}
	}		
	for (j=0;j<nfields;++j)
	{
		r1[j].fldlen[0]=0;
		r1[j].fldlen[1]=0;
		for(i=0;i<fieldlen;++i)
		{
			r1[j].flddata[i]=0;
		}
	}
		
	for(j=0;j<tnamel;++j)
	{
		ipt1[j]=0;
	}
	for(j=0;j<tnamel;++j)
	{
		ipt1[j]=(int)tname[j];
		inc[j]=(int)tname[j];
	}

	encrypt(strlen(tname),tnamel);

	for(i=0;i<4;++i)
	{
		tfname[i]=(ouc[i*4]<<24)&0xff000000;
		tfname[i]|=(ouc[i*4+1]<<16)&0xffff0000;
		tfname[i]|=(ouc[i*4+2]<<8)&0xffffff00;
		tfname[i]|=ouc[i*4+3];

		r0.tnme[i*4]=ouc[i*4];
		r0.tnme[i*4+1]=ouc[i*4+1];
		r0.tnme[i*4+2]=ouc[i*4+2];
		r0.tnme[i*4+3]=ouc[i*4+3];
	}
	//printf("%d %d %d %d\n",tfname[0],tfname[1],tfname[2],tfname[3]);
	recno=0;
	f2=fopen(fn2,"rb");

	while(!feof(f2))
	{

		mfname[0]=getc(f2)<<24;mfname[0]|=getc(f2)<<16;mfname[0]|=getc(f2)<<8;mfname[0]|=getc(f2);
		mfname[1]=getc(f2)<<24;mfname[1]|=getc(f2)<<16;mfname[1]|=getc(f2)<<8;mfname[1]|=getc(f2);
		mfname[2]=getc(f2)<<24;mfname[2]|=getc(f2)<<16;mfname[2]|=getc(f2)<<8;mfname[2]|=getc(f2);
		mfname[3]=getc(f2)<<24;mfname[3]|=getc(f2)<<16;mfname[3]|=getc(f2)<<8;mfname[3]|=getc(f2);
		mrecno=getc(f2)<<24;mrecno|=getc(f2)<<16;mrecno|=getc(f2)<<8;mrecno|=getc(f2);
		mpos=getc(f2)<<24;mpos|=getc(f2)<<16;mpos|=getc(f2)<<8;mpos|=getc(f2);


		//printf("%d %d\n",mfname[0],tfname[0]);
		if ((mfname[0]==tfname[0])&&(mfname[1]==tfname[1])&&(mfname[2]==tfname[2])&&(mfname[3]==tfname[3])){recno=mrecno;}
	}
	fclose(f2);

	if (recno==0){recno=1;}else{++recno;}
	
	r0.rn[0]=(recno&0xff000000)>>24;
	r0.rn[1]=(recno&0x00ff0000)>>16;
	r0.rn[2]=(recno&0x0000ff00)>>8;
	r0.rn[3]=(recno&0x000000ff);

	f1=fopen(fn1,"ab");
	fseek(f1,0,SEEK_END);
	pos=ftell(f1);

	printf("%d %d %d\n",recno,pos,index);

	//hl=20*3+index*(16*3)+index*3+index*(4*3);
	hl=20+index*(16)+index+index*(4);

	for(i=0;i<index;++i)
	{
		for(j=0;j<tnamel;++j)
		{
			ipt1[j]=0;
		}
		for(j=0;j<fnamel;++j)
		{
			if((int)fname[i][j]>0){ipt1[j]=(int)fname[i][j];inc[j]=(int)fname[i][j];}else{break;}
		}

		encrypt(strlen(fname[i]),fnamel);

		for(k=0;k<4;++k)
		{
			r0.fldn[i][k*4]=ouc[k*4];
			r0.fldn[i][k*4+1]=ouc[k*4+1];
			r0.fldn[i][k*4+2]=ouc[k*4+2];
			r0.fldn[i][k*4+3]=ouc[k*4+3];
		}
		
		r0.fldtyp[i]=ftype[i];

		for(j=0;j<fieldlen;++j)
		{
			if((int)darr[i][j]!=0){r1[i].flddata[j]=(int)darr[i][j];}else{break;}
		}

		r1[i].fldlen[0]=(j&0xff00)>>8;
		r1[i].fldlen[1]=(j&0x00ff);

		if (i==0)
		{
			fl[i]=pos+hl;
			r0.fldpos[i][0]=(fl[i]&0xff000000)>>24;
			r0.fldpos[i][1]=(fl[i]&0x00ff0000)>>16;
			r0.fldpos[i][2]=(fl[i]&0x0000ff00)>>8;
			r0.fldpos[i][3]=(fl[i]&0x000000ff);
			fl[i+1]=2+j;
		}else{
			l=0;for(m=0;m<=i;++m){l+=fl[m];}
			r0.fldpos[i][0]=(l&0xff000000)>>24;
			r0.fldpos[i][1]=(l&0x00ff0000)>>16;
			r0.fldpos[i][2]=(l&0x0000ff00)>>8;
			r0.fldpos[i][3]=(l&0x000000ff);
			fl[i+1]=2+j;
		}
	}

	for(j=0;j<4;++j)
	{

		putc(r0.tnme[j*4],f1);
		putc(r0.tnme[1+j*4],f1);
		putc(r0.tnme[2+j*4],f1);
		putc(r0.tnme[3+j*4],f1);

	}
	
	putc(r0.rn[0],f1);
	putc(r0.rn[1],f1);
	putc(r0.rn[2],f1);
	putc(r0.rn[3],f1);

	for(j=0;j<index;++j)
	{
		for(i=0;i<4;++i)
		{
			putc(r0.fldn[j][i*4],f1);
			putc(r0.fldn[j][1+i*4],f1);
			putc(r0.fldn[j][2+i*4],f1);
			putc(r0.fldn[j][3+i*4],f1);
		}
	}

	for(j=0;j<index;++j)
	{
		putc(r0.fldtyp[j],f1);
	}

	for(j=0;j<index;++j)
	{
		putc(r0.fldpos[j][0],f1);
		putc(r0.fldpos[j][1],f1);
		putc(r0.fldpos[j][2],f1);
		putc(r0.fldpos[j][3],f1);
	}


	for (i=0;i<index;++i)
	{
		k=0;
		k=r1[i].fldlen[0]<<8;
		k&=0xff00;
		k|=r1[i].fldlen[1];

		//printf("%d\n",k);
		putc(r1[i].fldlen[0],f1);
		putc(r1[i].fldlen[1],f1);


		for(j=0;j<k;++j)
		{
			putc(r1[i].flddata[j],f1);
		}
	}
	fclose(f1);

	f2=fopen(fn2,"ab");

	//printf("%010d%010d%010d%010d%010d%010d",tfname[0],tfname[1],tfname[2],tfname[3],recno,pos);
	putc((tfname[0]&0xff000000)>>24,f2);putc((tfname[0]&0x00ff0000)>>16,f2);putc((tfname[0]&0x0000ff00)>>8,f2);putc(tfname[0]&0x000000ff,f2);
	putc((tfname[1]&0xff000000)>>24,f2);putc((tfname[1]&0x00ff0000)>>16,f2);putc((tfname[1]&0x0000ff00)>>8,f2);putc(tfname[1]&0x000000ff,f2);
	putc((tfname[2]&0xff000000)>>24,f2);putc((tfname[2]&0x00ff0000)>>16,f2);putc((tfname[2]&0x0000ff00)>>8,f2);putc(tfname[2]&0x000000ff,f2);
	putc((tfname[3]&0xff000000)>>24,f2);putc((tfname[3]&0x00ff0000)>>16,f2);putc((tfname[3]&0x0000ff00)>>8,f2);putc(tfname[3]&0x000000ff,f2);
	putc((recno&0xff000000)>>24,f2);putc((recno&0x00ff0000)>>16,f2);putc((recno&0x0000ff00)>>8,f2);putc(recno&0x000000ff,f2);
	putc((pos&0xff000000)>>24,f2);putc((pos&0x00ff0000)>>16,f2);putc((pos&0x0000ff00)>>8,f2);putc(pos&0x000000ff,f2);


	fclose(f2);
	return(recno);
}

void ms915(char fn1[],char fn2[],int nfld, char tname[tnamel], char fname[nfields][fnamel],unsigned int ftype[nfields],int flength[nfields],char fdata[nfields][fieldlen])
{

	FILE			*f1,*f2;
	int			i,j;
	char			darr[nfields][fieldlen];
	
	f1=fopen(f11ns,"rb");if(f1==NULL){f1=fopen(f11ns,"wb");fclose(f1);}else{fclose(f1);}
	f2=fopen(f13ns,"rb");if(f2==NULL){f2=fopen(f13ns,"wb");fclose(f2);}else{fclose(f2);}		

	for(j=0;j<nfld;++j){for(i=0;i<flength[j];++i){darr[j][i]=fdata[j][i];}}

	//printf(" %s %s %s %s %s\n",fn1,fn2,tname1a,fname[0],darr[0]);
	//printf(" %s %s %s %s %s\n",fn1,fn2,tname1a,fname[1],darr[1]);
	s915(fn1,fn2,tname,fname,ftype,darr);
}

int p313(char tname[tnamel],char fname[nfields][fnamel],int indexc,char fcond[fnamel],char coper[fnamel],char coprnd[fnamel],char outfn[fnamel],bool lb,bool qf)
{

	unsigned		fbyte,fct[nfields];
	int			i,j,k,l,m,m1,n,hl,ipt1[carrl],rrc=0,rv=0;			
	unsigned long		hresult,index[nfields][3],tpos;
	unsigned long		tfname[4],recno,pos,ffname[nfields][4];
	unsigned long		mfname[4],mrecno,mpos;
	bool			exitF=false;
	char			err1[fieldlen];



	for(j=0;j<nfields;++j)
	{
		index[j][0]=0;
		index[j][1]=0;
		index[j][2]=0;
	}
	for(j=0;j<tnamel;++j)
	{
		ipt1[j]=0;
	}
	for(j=0;j<tnamel;++j)
	{
		ipt1[j]=(int)tname[j];
		inc[j]=(int)tname[j];
	}

	encrypt(strlen(tname),tnamel);

	for(i=0;i<4;++i)
	{
		tfname[i]=(ouc[i*4]<<24)&0xff000000;
		tfname[i]|=(ouc[i*4+1]<<16)&0xffff0000;
		tfname[i]|=(ouc[i*4+2]<<8)&0xffffff00;
		tfname[i]|=ouc[i*4+3];
	}

	recno=0;
	f13=fopen(f13np,"rb");
	f11=fopen(f11np,"rb");
	if (p_strlen(outfn)>0){for(m1=0;m1<fieldlen;++m1){err1[m1]=' ';}m1=0;f15=fopen(outfn,"w");}
	while(!feof(f13))
	{
		if (p_strlen(outfn)==0&&exitF){break;}

		mfname[0]=(getc(f13)<<24)&0xff000000;mfname[0]|=(getc(f13)<<16)&0xffff0000;mfname[0]|=(getc(f13)<<8)&0xffffff00;mfname[0]|=getc(f13);
		mfname[1]=(getc(f13)<<24)&0xff000000;mfname[1]|=(getc(f13)<<16)&0xffff0000;mfname[1]|=(getc(f13)<<8)&0xffffff00;mfname[1]|=getc(f13);
		mfname[2]=(getc(f13)<<24)&0xff000000;mfname[2]|=(getc(f13)<<16)&0xffff0000;mfname[2]|=(getc(f13)<<8)&0xffffff00;mfname[2]|=getc(f13);
		mfname[3]=(getc(f13)<<24)&0xff000000;mfname[3]|=(getc(f13)<<16)&0xffff0000;mfname[3]|=(getc(f13)<<8)&0xffffff00;mfname[3]|=getc(f13);
		mrecno=getc(f13)<<24;mrecno|=getc(f13)<<16;mrecno|=getc(f13)<<8;mrecno|=getc(f13);
		mpos=getc(f13)<<24;mpos|=getc(f13)<<16;mpos|=getc(f13)<<8;mpos|=getc(f13);


		//printf("%d %d\n",mfname[0],tfname[0]);
		//printf("%d %d %d %d\n",mfname[0],mfname[1],mfname[2],mfname[3]);
		//printf("%d %d %d %d\n",tfname[0],tfname[1],tfname[2],tfname[3]);
		if ((mfname[0]==tfname[0])&&(mfname[1]==tfname[1])&&(mfname[2]==tfname[2])&&(mfname[3]==tfname[3]))
		{
			recno=mrecno;
			fseek(f11,mpos+20,SEEK_SET);
			//printf("%d %d\n",mrecno,mpos);
			//hl=20;//+indexc*16; //+indexc+indexc*4;
			//k=1;
			//fct[0]=0;fct[1]=0;fct[2]=0;fct[3]=0;
			//fscanf(f11,"%03d",&fct[0]);
			//while(k<hl)
			//{
			//	fct[0]=0;fct[1]=0;fct[2]=0;fct[3]=0;
			//	fscanf(f11,"%03d",&fct[0]);
			//	++k;
			//}

			for(l=0;l<indexc;l++)
			{
				fct[0]=0;fct[1]=0;fct[2]=0;fct[3]=0;
				//fscanf(f11,"%03d%03d%03d%03d",&fct[0],&fct[1],&fct[2],&fct[3]);
				fct[0]=getc(f11);
				fct[1]=getc(f11);
				fct[2]=getc(f11);
				fct[3]=getc(f11);

				mfname[0]=0;
				mfname[0]|=(fct[0]<<24)&0xff000000;
				mfname[0]|=(fct[1]<<16)&0xffff0000;
				mfname[0]|=(fct[2]<<8)&0xffffff00;
				mfname[0]|=fct[3];

				fct[0]=0;fct[1]=0;fct[2]=0;fct[3]=0;

				fct[0]=getc(f11);
				fct[1]=getc(f11);
				fct[2]=getc(f11);
				fct[3]=getc(f11);

				mfname[1]=0;
				mfname[1]|=(fct[0]<<24)&0xff000000;
				mfname[1]|=(fct[1]<<16)&0xffff0000;
				mfname[1]|=(fct[2]<<8)&0xffffff00;
				mfname[1]|=fct[3];

				fct[0]=0;fct[1]=0;fct[2]=0;fct[3]=0;

				fct[0]=getc(f11);
				fct[1]=getc(f11);
				fct[2]=getc(f11);
				fct[3]=getc(f11);

				mfname[2]=0;
				mfname[2]|=(fct[0]<<24)&0xff000000;
				mfname[2]|=(fct[1]<<16)&0xffff0000;
				mfname[2]|=(fct[2]<<8)&0xffffff00;
				mfname[2]|=fct[3];

				fct[0]=0;fct[1]=0;fct[2]=0;fct[3]=0;

				fct[0]=getc(f11);
				fct[1]=getc(f11);
				fct[2]=getc(f11);
				fct[3]=getc(f11);

				mfname[3]=0;
				mfname[3]|=(fct[0]<<24)&0xff000000;
				mfname[3]|=(fct[1]<<16)&0xffff0000;
				mfname[3]|=(fct[2]<<8)&0xffffff00;
				mfname[3]|=fct[3];

				if(fname[l][0]!='\0')
				{
					for(j=0;j<tnamel;++j)
					{
						ipt1[j]=0;
					}
					for(j=0;j<fnamel;++j)
					{
						if((int)fname[l][j]>0){ipt1[j]=(int)fname[l][j];inc[j]=(int)fname[l][j];}else{break;}
					}

					encrypt(strlen(fname[l]),fnamel);

					for(i=0;i<4;++i)
					{
						ffname[l][i]=(ouc[i*4]<<24)&0xff000000;
						ffname[l][i]|=(ouc[i*4+1]<<16)&0xffff0000;
						ffname[l][i]|=(ouc[i*4+2]<<8)&0xffffff00;
						ffname[l][i]|=ouc[i*4+3];
					}

					//printf("%s\n",fname[l]);
					//printf("%d %d %d %d\n",mfname[0],mfname[1],mfname[2],mfname[3]);
					//printf("%d %d %d %d\n",ffname[l][0],ffname[l][1],ffname[l][2],ffname[l][3]);

					if (mfname[0]==ffname[l][0]&&mfname[1]==ffname[l][1]&&mfname[2]==ffname[l][2]&&mfname[3]==ffname[l][3]){index[l][0]=1;/*printf("!");*/}
				}else{index[l][0]=0;}
			}

			for (i=0;i<indexc;++i)
			{
				fct[0]=0;fct[1]=0;fct[2]=0;fct[3]=0;

				fct[0]=getc(f11);
				index[i][1]=(long)fct[0];
				//printf("Type:%d ",index[i][1]);
			}
			hl=indexc*4;
			i=0;
			k=0;
			fct[0]=0;fct[1]=0;fct[2]=0;fct[3]=0;

			fct[0]=getc(f11);
			fct[1]=getc(f11);
			fct[2]=getc(f11);
			fct[3]=getc(f11);
			index[i][2]=(fct[0]<<24)&0xff000000;
			index[i][2]|=(fct[1]<<16)&0xffff0000;
			index[i][2]|=(fct[2]<<8)&0xffffff00;
			index[i][2]|=fct[3];
			k+=4;	
			while(k<=indexc*4)
			{
				//printf("Pos:%d ",index[i][2]);
				++i;
				fct[0]=0;fct[1]=0;fct[2]=0;fct[3]=0;

				fct[0]=getc(f11);
				fct[1]=getc(f11);
				fct[2]=getc(f11);
				fct[3]=getc(f11);
				index[i][2]=(fct[0]<<24)&0xff000000;
				index[i][2]|=(fct[1]<<16)&0xffff0000;
				index[i][2]|=(fct[2]<<8)&0xffffff00;
				index[i][2]|=fct[3];
				k+=4;	
			}

			if(qf)
			{
				for(n=0;n<indexc;++n)
				{
					//printf(" %s ",cmva[n]);
					for(i=0;i<indexc;++i)
					{
						if(1==p_comp(cmva[n],fname[i]))
						{
						//printf("inner:%s ",fname[i]);
							if(index[i][0]==1)
							{
								if (p_strlen(outfn)==0){if (p_strlen(fcond)==0){printf("! Column: %s\n",fname[i]);}}
								fseek(f11,index[i][2],SEEK_SET);		
								k=0;
								fct[0]=0;fct[1]=0;fct[2]=0;fct[3]=0;

								fct[0]=getc(f11);
								k=fct[0]<<8;
								k&=0xff00;
								fct[0]=0;fct[1]=0;fct[2]=0;fct[3]=0;
		
								fct[0]=getc(f11);
								k|=fct[0];
								//printf("!k:%d ",k);
								m=0;for(j=0;j<nopt;++j){err[j]='\0';}
								for (j=0;j<k;++j)
								{
									fct[0]=0;fct[1]=0;fct[2]=0;fct[3]=0;

									fct[0]=getc(f11);
									if (p_strlen(outfn)>0)
									{
										if (fct[0]>=32&&fct[0]<=126){err1[m1]=(char)fct[0];++m1;}
										if (lb)
										{
											if (j==k-1/*&&i==indexc-1*/)
											{
													err1[m1]='\0';
													fprintf(f15,"%s ",err1);
													/*printf("%s\n",err1);*/
													for(m1=0;m1<fieldlen;++m1){err1[m1]=' ';}
													m1=0;
											}
										}
										if (!lb)
										{
											if (j==k-1)
											{
												err1[m1]='\0';
												fprintf(f15,"%s\n",err1);
												/*printf("%s\n",err1);*/
												for(m1=0;m1<fieldlen;++m1){err1[m1]=' ';}
												m1=0;
											}
										}
									}
									//printf("%c",fct[0]);
									if (p_strlen(fcond)>0)
									{
										if (1==p_comp(fname[i],fcond))
										{
											if (fct[0]>=32&&fct[0]<=126){/*printf("%c",fct[0]);*/err[m]=(char)fct[0];++m;}
											//printf("%s %s ",err,coprnd);
											if ((j==k-1)&&(1==p_comp(err,coprnd)))
											{
												rv=1;exitF=true;
											}
										}
									}else{
										if (p_strlen(outfn)==0){if (fct[0]>=32&&fct[0]<=126){printf("%c",fct[0]);}else{/*printf("%03d",fct[0]);*/}}
									}
								}
								if (p_strlen(outfn)==0){if (p_strlen(fcond)==0){printf("\n");}}
							}else{
								if(index[i][0]==0)
								{
									fseek(f11,index[i][2],SEEK_SET);		
									k=0;
									fct[0]=0;fct[1]=0;fct[2]=0;fct[3]=0;

									fct[0]=getc(f11);
									k=fct[0]<<8;
									k&=0xff00;
									fct[0]=0;fct[1]=0;fct[2]=0;fct[3]=0;

									fct[0]=getc(f11);
									k|=fct[0];
									for (j=0;j<k;++j)
									{
										fct[0]=0;fct[1]=0;fct[2]=0;fct[3]=0;

										fct[0]=getc(f11);
										//if (p_strlen(outfn)>0)
										//{
										//	if (fct[0]>=32&&fct[0]<=126){err1[m1]=(char)fct[0];++m1;}
										//	if (j==k-1){err1[m1]='\0';fprintf(f15,"%s\n",err1);/*printf("%s\n",err1);*/for(m1=0;m1<fieldlen;++m1){err1[m1]=' ';}m1=0;}
										//}
									}
								}
							}
							break;
						}
					}
				}
				if (p_strlen(outfn)>0&&lb){fprintf(f15,"\n");}
				++rrc;
			}else{
				for (i=0;i<indexc;++i)
				{
					if (p_strlen(outfn)==0&&exitF){break;}
					if(index[i][0]==1)
					{
						if (p_strlen(outfn)==0){if (p_strlen(fcond)==0){printf("! Column: %s\n",fname[i]);}}
						fseek(f11,index[i][2],SEEK_SET);		
						k=0;
						fct[0]=0;fct[1]=0;fct[2]=0;fct[3]=0;

						fct[0]=getc(f11);
						k=fct[0]<<8;
						k&=0xff00;
						fct[0]=0;fct[1]=0;fct[2]=0;fct[3]=0;

						fct[0]=getc(f11);
						k|=fct[0];
						//printf("!k:%d ",k);
						m=0;for(j=0;j<nopt;++j){err[j]='\0';}
						for (j=0;j<k;++j)
						{
							fct[0]=0;fct[1]=0;fct[2]=0;fct[3]=0;

							fct[0]=getc(f11);
							if (p_strlen(outfn)>0)
							{
								if (fct[0]>=32&&fct[0]<=126){err1[m1]=(char)fct[0];++m1;}
								if (lb)
								{
									if (j==k-1/*&&i==indexc-1*/)
									{
										err1[m1]='\0';
										fprintf(f15,"%s ",err1);
										/*printf("%s\n",err1);*/
										for(m1=0;m1<fieldlen;++m1){err1[m1]=' ';}
										m1=0;
									}
								}
								if (!lb)
								{
									if (j==k-1)
									{
										err1[m1]='\0';
										fprintf(f15,"%s\n",err1);
										/*printf("%s\n",err1);*/
										for(m1=0;m1<fieldlen;++m1){err1[m1]=' ';}
										m1=0;
									}
								}
							}
							//printf("%c",fct[0]);
							if (p_strlen(fcond)>0)
							{
								if (1==p_comp(fname[i],fcond))
								{
									if (fct[0]>=32&&fct[0]<=126){/*printf("%c",fct[0]);*/err[m]=(char)fct[0];++m;}
									//printf("%s %s ",err,coprnd);
									if ((j==k-1)&&(1==p_comp(err,coprnd)))
									{
										rv=1;exitF=true;
									}
								}
							}else{
								if (p_strlen(outfn)==0){if (fct[0]>=32&&fct[0]<=126){printf("%c",fct[0]);}else{/*printf("%03d",fct[0]);*/}}
							}
						}
						if (p_strlen(outfn)==0){if (p_strlen(fcond)==0){printf("\n");}}
					}else{
						if(index[i][0]==0)
						{
							fseek(f11,index[i][2],SEEK_SET);		
							k=0;
							fct[0]=0;fct[1]=0;fct[2]=0;fct[3]=0;

							fct[0]=getc(f11);
							k=fct[0]<<8;
							k&=0xff00;
							fct[0]=0;fct[1]=0;fct[2]=0;fct[3]=0;

							fct[0]=getc(f11);
							k|=fct[0];
							for (j=0;j<k;++j)
							{
								fct[0]=0;fct[1]=0;fct[2]=0;fct[3]=0;

								fct[0]=getc(f11);
								//if (p_strlen(outfn)>0)
								//{
								//	if (fct[0]>=32&&fct[0]<=126){err1[m1]=(char)fct[0];++m1;}
								//	if (j==k-1){err1[m1]='\0';fprintf(f15,"%s\n",err1);/*printf("%s\n",err1);*/for(m1=0;m1<fieldlen;++m1){err1[m1]=' ';}m1=0;}
								//}
							}
						}
					}

				}
				if (p_strlen(outfn)>0&&lb){fprintf(f15,"\n");}
				++rrc;
			}
		}
	}
	printf("(%d) Rows Retrived\n",rrc);
	fclose(f13);
	fclose(f11);
	if (p_strlen(outfn)>0){fclose(f15);}
	if (p_strlen(fcond)>0){return(rv);}else{return(rrc);}
}

void p5(int count)
{
	unsigned		fbyte;
	int				i=0,j=0,kwi=0,vari=0,k,l,m,n,p,q;
	char			line1[stlen],line2[stlen];

	i=0;
	fseek(f1,st_ord_arr[i][0],SEEK_SET);

	while(i<count)
	{
			for (k=0;k<stlen;++k)
			{
				line1[k]='\0';
				line2[k]='\0';
			}
			kwi=0;vari=0;
			fbyte=getc(f1);
			while(!feof(f1)&&ftell(f1)<st_ord_arr[i+1][0])
			{
				if (fbyte==' '||fbyte=='|'||fbyte=='('||fbyte==')'){line1[kwi]=fbyte;++kwi;line2[vari]=fbyte;++vari;}else
				{	
					if ((fbyte>='A'&&fbyte<='Z'))
					{
						line1[kwi]=fbyte;++kwi;
					}else{
						if ((fbyte>='a'&&fbyte<='z')||fbyte=='_'||fbyte=='*'||fbyte==','||fbyte=='.')
						{
							line2[vari]=fbyte;++vari;
						}
					}
				}
				fbyte=getc(f1);
			}

			//printf("Keywords:  %s\n",line1);
			//printf("Variables: %s\n",line2);

			for (m=0;m<stlen;++m)
			{
				stmnt[st_att_i].kew[m]=line1[m];
				stmnt[st_att_i].var[m]=line2[m];
			}

			if (st_ord_arr[i][1]=='{'){stmnt[st_att_i].opt=1;}
				else{if (st_ord_arr[i][1]=='['){stmnt[st_att_i].opt=2;}else{stmnt[st_att_i].opt=3;}}

			if(i==0)
			{
				stmnt[st_att_i].prev=999;
				rta[ri]=st_att_i;
				++ri;
			}else{stmnt[st_att_i].prev=st_att_i-1;}

			stmnt[st_att_i].next=st_att_i+1;
			stmnt[st_att_i].opti=pai;

			if (st_ord_arr[i][1]=='['&&st_ord_arr[i+1][1]==']'&&i>0){stmnt[st_att_i].prev=rta[ri-1];}
			if (st_ord_arr[i][1]=='{'&&st_ord_arr[i+1][1]=='}'&&i>0){stmnt[st_att_i].prev=rta[ri-1];}
			++st_att_i;					
			++i;
			fseek(f1,st_ord_arr[i][0],SEEK_SET);
		}
		stmnt[st_att_i-1].next=0;
		//for (i=0;i<st_att_i;++i)
		//{
		//	printf("%s\n%s\n%d\n%d\n%d\n",stmnt[i].kew,stmnt[i].var,i,stmnt[i].prev,stmnt[i].next);
		//}
}

int p3()
{

	unsigned		fbyte;
	char			kw[nopt]="",stata[nopt]="",sline[nopt];
	int				i,j,k,lc,o_lc,n,n1;
	long			sspos,espos,tspos;
	bool			psynt;

	i=0;fbyte=getc(f2);j=0;
	while(!feof(f2)&&fbyte!=tc)
	{
		stata[i]=(char)fbyte;
		if (fbyte==' '&&j==0) {strncat(kw,stata,i);strcat(kw,"\0");++j;}
		fbyte=getc(f2);
		++i;
	}

	for (j=0;j<p_strlen(kw);++j)
	{
		kw[j]=(char)toupper((int)kw[j]);
	}

	//printf("!%s!\n",kw);
	fclose(f2);

	for (i=0;i<nopt;++i){sline[i]='\0';}
	psynt=false;fbyte=getc(f1);
	while(!feof(f1))
	{
		if (fbyte=='>') 
		{
			i=0;fbyte=getc(f1);
			while(fbyte!=' ')
			{
				sline[i]=fbyte;
				fbyte=getc(f1);
				++i;
			}
			//printf("!%s!\n",kw);
			//printf("!%s!\n",sline);
			strcat(sline,"\0");
			if(1==p_comp(kw,sline)){psynt=true;break;}
		}
		fbyte=getc(f1);
	}

	if (psynt)
	{
		fbyte=getc(f1);
		while(!feof(f1)&&fbyte!='>')
		{
			if (fbyte=='[')
			{
				for (j=0;j<nopt;++j)
				{
					st_ord_arr[j][0]=0;
					st_ord_arr[j][1]=0;
				}
				j=0;
				st_ord_arr[j][0]=ftell(f1);
				st_ord_arr[j][1]='[';
				o_lc=1;lc=0;
				sspos=ftell(f1);
				fbyte=getc(f1);
				while(!feof(f1)&&fbyte!='>')
				{
					if (fbyte=='[')
					{
						++o_lc;
						++j;
						st_ord_arr[j][0]=ftell(f1);
						st_ord_arr[j][1]='[';
					}
					if (fbyte=='{')
					{
						++lc;
						++j;
						st_ord_arr[j][0]=ftell(f1);
						st_ord_arr[j][1]='{';
					}
					if (fbyte==']')
					{
						--o_lc;
						++j;
						st_ord_arr[j][0]=ftell(f1);
						st_ord_arr[j][1]=']';						
						if (o_lc==0){espos=ftell(f1);break;}
					}
					if (fbyte=='}')
					{
						--lc;
						++j;
						st_ord_arr[j][0]=ftell(f1);
						st_ord_arr[j][1]='}';						
					}
					fbyte=getc(f1);
				}
				//printf("Option\n");
				n1=1;pa[pai].prc[0][0]=1;pa[pai].prc[0][1]=0;
				for (n=1;n<j;++n)
				{
					if (st_ord_arr[n][1]=='{'){pa[pai].prc[n1][0]=2;++n1;}else{
						if (st_ord_arr[n][1]=='['){pa[pai].prc[n1][0]=1;++n1;}else{
							if (st_ord_arr[n][1]=='|'){pa[pai].prc[n1][0]=3;++n1;}
						}
					}
				}
				tspos=ftell(f1);
				p5(j);
				++pai;
				fseek(f1,tspos,SEEK_SET);

			}else{
				if (fbyte=='{')
				{
					for (j=0;j<nopt;++j)
					{
						st_ord_arr[j][0]=0;
						st_ord_arr[j][1]=0;
					}
					j=0;
					st_ord_arr[j][0]=ftell(f1);
					st_ord_arr[j][1]='{';
					lc=1;o_lc=0;
					sspos=ftell(f1);
					fbyte=getc(f1);
					while(!feof(f1)&&fbyte!='>')
					{
						if (fbyte=='[')
						{
							++o_lc;
							++j;
							st_ord_arr[j][0]=ftell(f1);
							st_ord_arr[j][1]='[';
						}
						if (fbyte==']')
						{
							--o_lc;
							++j;
							st_ord_arr[j][0]=ftell(f1);
							st_ord_arr[j][1]=']';						
						}
						if (fbyte=='{')
						{
							++lc;
							++j;
							st_ord_arr[j][0]=ftell(f1);
							st_ord_arr[j][1]='{';
						}
						if (fbyte=='}')
						{
							--lc;
							++j;
							st_ord_arr[j][0]=ftell(f1);
							st_ord_arr[j][1]='}';						
							if (lc==0){espos=ftell(f1);break;}
						}
						fbyte=getc(f1);
					}
					//printf("Component\n");
					n1=1;pa[pai].prc[0][0]=2;pa[pai].prc[0][1]=0;
					for (n=1;n<j;++n)
					{
						if (st_ord_arr[n][1]=='{'){pa[pai].prc[n1][0]=2;++n1;}else{
							if (st_ord_arr[n][1]=='['){pa[pai].prc[n1][0]=1;++n1;}else{
								if (st_ord_arr[n][1]=='|'){pa[pai].prc[n1][0]=3;++n1;}
							}
						}
					}
					tspos=ftell(f1);
					p5(j);
					++pai;
					fseek(f1,tspos,SEEK_SET);
				}
			}
			fbyte=getc(f1);
		}
	}else{fclose(f1);return(0);}
	fclose(f1);
	return(1);
}

int p91(int rind,char st[nopt],int ti)
{
	int		i,j,k,l,n;
	bool	uc=false;

	for (i=0;i<p_strlen(st);++i)
	{
		if (st[i]>='A'&&st[i]<='Z'){uc=true;break;}
	}

	for (i=0;i<p_strlen(st);++i)
	{
		for (j=0;j<stlen;++j)
		{
			if (uc) {if (st[i]==stmnt[rind].kew[j]){break;}}else{if (st[i]==stmnt[rind].var[j]){break;}}
		}
		l=0;
		for (k=j;k<j+strlen(st);++k)
		{
			if (uc) {if (st[i+l]==stmnt[rind].kew[k]){++l;}else{break;}}else{if (st[i+l]==stmnt[rind].var[k]){++l;}else{break;}}
		}
		if (k==j+strlen(st)-1){break;}
	}
	if (k==j+strlen(st)-1)
	{
		if (pa[rind].prc[ti][1]==1){printf("!Level 3. Required Token Redundant/Repeat: %s\n",st);return(0);}

		if (rind>0)
		{
			for (n=0;n<rind;++n)
			{
				if (pa[n].prc[0][0]==2&&pa[n].prc[0][1]==0){break;}
			}
			if (n==rind)
			{
				printf("!Level 1. Required Token Missing ex: %s\n",stmnt[rind-1].kew);return(0);
			}//else{printf("%s %d ok..\n",st,pa[stmnt[rind].opti].prc[ti][0]);pa[stmnt[rind].opti].prc[ti][1]=1;return(1);}
		}

		if (ti>0)
		{
			for (n=0;n<ti;++n)
			{
				if (pa[n].prc[0][0]==3&&pa[n].prc[0][1]==0){if (pa[rind].prc[n][0]==1&&pa[rind].prc[n][1]==0){break;}}
			}
			if (n<ti)
			{
				printf("!Level 2. Required Token Missing ex: %s\n",stmnt[rind-1].kew);return(0);
			}else{printf("%s <L 1.2.:%d ok..>\n",st,pa[stmnt[rind].opti].prc[ti][0]);pa[stmnt[rind].opti].prc[ti][1]=1;return(1);}
		}else{printf("%s <L 1.0.:%d ok..>\n",st,pa[stmnt[rind].opti].prc[ti][0]);pa[stmnt[rind].opti].prc[ti][1]=1;return(1);}
	}else{/*printf("%s err.",stmnt[rind].kew);*/return(0);}	
}

long p7()
{
	int			i,j,k,l,ti;
	char		kw[nopt]="",stata[nopt]="";
	unsigned	fbyte;
	long		pos;

	for (i=0;i<nopt;++i)
	{
		stata[i]='\0';
		kw[i]='\0';
	}

	i=0;j=0;
	fbyte=getc(f2);
	while(!feof(f2)&&fbyte!=tc)
	{
		stata[i]=(char)fbyte;
		if (fbyte==' ') 
		{
			for (k=0;k<nopt;++k)
			{
				kw[k]='\0';
			}
			strncat(kw,stata,i);
			strcat(kw,"\0");
			++j;
			break;
		}
		fbyte=getc(f2);
		++i;
	}
	
	for (l=0;l<st_att_i;++l)
	{
		if (stmnt[l].prev==999)
		{
			if(stmnt[l].next==0)
			{
				//printf("1 1. %s\n",stmnt[l].kew);
				//printf("1 2. %s\n",stmnt[l].var);

				for (i=0;i<nopt;++i)
				{
					stata[i]='\0';
					kw[i]='\0';
				}
				i=0;ti=0;
				pos=ftell(f2);
				fbyte=getc(f2);
				while(!feof(f2)&&fbyte!=tc)
				{
					stata[i]=(char)fbyte;
					if (fbyte==' ') 
					{
						strncat(kw,stata,i);
						strcat(kw,"\0");
						++j;
						if (p91(l,kw,ti)!=1){fseek(f2,pos,SEEK_SET);strcpy(err,kw);}
						break;
					}
					fbyte=getc(f2);
					++i;
				}

			}else{
				//printf("2 1. %s\n",stmnt[l].kew);
				//printf("2 2. %s\n",stmnt[l].var);

				for (i=0;i<nopt;++i)
				{
					stata[i]='\0';
					kw[i]='\0';
				}
				i=0;++ti;
				pos=ftell(f2);
				fbyte=getc(f2);
				while(!feof(f2)&&fbyte!=tc)
				{
					stata[i]=(char)fbyte;
					if (fbyte==' ') 
					{
						strncat(kw,stata,i);
						strcat(kw,"\0");
						++j;
						if (p91(l,kw,ti)!=1){fseek(f2,pos,SEEK_SET);strcpy(err,kw);}
						break;
					}
					fbyte=getc(f2);
					++i;
				}


				k=stmnt[l].next;
				while(stmnt[k].next!=0)
				{
					//printf("3 1. %s\n",stmnt[k].kew);
					//printf("3 2. %s\n",stmnt[k].var);

					
					for (i=0;i<nopt;++i)
					{
						stata[i]='\0';
						kw[i]='\0';
					}
					i=0;++ti;
					pos=ftell(f2);
					fbyte=getc(f2);
					while(!feof(f2)&&fbyte!=tc)
					{
						stata[i]=(char)fbyte;
						if (fbyte==' ') 
						{
							strncat(kw,stata,i);
							strcat(kw,"\0");
							++j;
							if (p91(k,kw,ti)!=1){fseek(f2,pos,SEEK_SET);strcpy(err,kw);}
							break;
						}
						fbyte=getc(f2);
						++i;
					}

					k=stmnt[k].next;
				}

				//printf("4 1. %s\n",stmnt[k].kew);
				//printf("4 2. %s\n",stmnt[k].var);

				for (i=0;i<nopt;++i)
				{
					stata[i]='\0';
					kw[i]='\0';
				}
				i=0;++ti;
				pos=ftell(f2);
				fbyte=getc(f2);
				while(!feof(f2)&&fbyte!=tc)
				{
					stata[i]=(char)fbyte;
					if (fbyte==' ') 
					{
						strncat(kw,stata,i);
						strcat(kw,"\0");
						++j;
						if (p91(k,kw,ti)!=1){fseek(f2,pos,SEEK_SET);strcpy(err,kw);}
						break;
					}
					fbyte=getc(f2);
					++i;
				}
			}
		}
	}
	return(pos);
}

int p9()
{
	int		i,j,k,l,m,n,o,p;
	int		bsw=0;
	unsigned	fbyte;
	char		ln[nopt]="",lkw[50]="",outln[nopt]="",kw[50]="";
	char		loper1[fnamel]="or";
	char		loper2[fnamel]="and";
	bool		errf=false;

	f3=fopen(f3n,"rb");
	f4=fopen(f4n,"rb");

	for (i=0;i<50;++i){kw[i]='\0';lkw[i]='\0';}

	for (i=0;i<nopt;++i){ln[i]='\0';outln[i]='\0';}

	i=0;
	fbyte=getc(f4);
	while(!feof(f4))
	{
		ln[i]=fbyte;++i;
		fbyte=getc(f4);
	}
	fclose(f4);
	ln[++i]=' ';ln[++i]='\0';

	m=0;n=0;
	for (j=0;j<p_strlen(ln);++j)
	{
		if(ln[j]!=' '){outln[m]=ln[j];++m;n=0;}else{++n;}
		if(n==1){outln[m]=ln[j];++m;}else{}
	}

	for (i=0;i<nopt;++i){ln[i]='\0';}
	m=0;for (i=0;i<p_strlen(outln);++i){ln[m]=outln[i];++m;}
	for (i=0;i<nopt;++i){outln[i]='\0';}

	n=0;m=0;
	for (j=0;j<p_strlen(ln)&&!errf;++j)
	{

		if(ln[j]=='"'&&bsw==0){bsw=1;outln[m]='"';++m;++j;}
		if(ln[j]=='"'&&bsw==1){bsw=0;outln[m]='"';++m;++j;}

		if(bsw==0)
		{
			if(j==0||ln[j]==' ')
			{
				if(ln[j]==' '){outln[m]=' ';++m;++j;}
				for (p=j;p<p_strlen(ln);++p)
				{
					if(ln[p]>='a'&&ln[p]<='z'){kw[n]=ln[p];++n;}else{
						if(ln[p]>=' ')
						{
							kw[n]='\0';
							fseek(f3,0,SEEK_SET);
							fscanf(f3,"%s\n",&lkw);
							while(!feof(f3))
							{
								if(p_strlen(kw)==p_strlen(lkw))
								{
									for (l=0;l<p_strlen(kw);++l)
									{
										if (kw[l]-32!=lkw[l]){break;}
									}
									if (l==strlen(kw)){break;}
								}
								fscanf(f3,"%s\n",&lkw);
							}
							if(feof(f3))
							{
								if((1==p_comp(kw,loper1))||(1==p_comp(kw,loper2)))
								{
									for(l=0;l<p_strlen(kw);++l){outln[m]=kw[l];++m;}
								}else{errf=true;}
							}else{for(l=0;l<p_strlen(lkw);++l){outln[m]=lkw[l];++m;}}
							outln[m]=' ';++m;
							n=0;j=p;break;
						}else{
								for(l=0;l<n;++l)
								{
									outln[m]=kw[l];++m;
								}
								n=0;j=p;break;
						}
					}
			
				}
			}else{outln[m]=ln[j];++m;}

		}else{outln[m]=ln[j];++m;}
	}

	//printf("Entered:%s\n",outln);

	if(!errf)
	{
		outln[m]=' ';++m;
		f2=fopen(f2n,"wb");
		printf("\n%s\n",outln);
		fprintf(f2,"%s",outln);
		fclose(f2);
		fclose(f3);
		for(j=0;j<nopt;++j){err[j]='\0';}
		strcpy(err,outln);
		return(1);
	}else{
			printf("\n!Level 0. Unknown SQL Keyword: %s\n",kw);
			return(0);
	}
}

int p_parse()
{
	int			i,j,k;
	long		p;
	unsigned	fbyte;

	f1=fopen(f1n,"rb");
	f2=fopen(f2n,"rb");
	st_att_i=0;ri=0;pai=0;
	if (1==p3())
	{
		f2=fopen(f2n,"rb");
		p=p7();
		fseek(f2,p,SEEK_SET);
		fbyte=getc(f2);
		while(!feof(f2)&&fbyte!=tc)
		{
			if (fbyte==' '||fbyte=='"'){fbyte=getc(f2);}else{break;}
		}
		if (feof(f2)){printf("\nParse Ok...\n");fclose(f2);return(1);}else{printf("\nError Parsing at Token : %s\n",err);fclose(f2);return(0);}
	}else{printf("\nUnknown SQL Command\n");}
}

int p3171(char fname2[fnamel],char fname3[fnamel])
{
	int	i,j,k,l,m;
	long	pos1;
	char	fname1[fnamel];
	char	fbyte;
	int	occ=0;

	char	c1[nopt];
	int	c1i=0;
	char	c2[nopt];
	int	c2i=0;
	char	c21[nopt];
	int	c21i=0;
	char	c3[4*nopt];
	int	c3i=0;
	bool	sf=false;

	strcpy(fname1,fname2);
	
	if(fname2[4]=='E'){fname1[4]='D';fi15=fopen(fname1,"rb");fbyte=getc(fi15);if(feof(fi15)){fclose(fi15);fname1[4]='C';}}else{
	if(fname2[4]=='D'){fname1[4]='C';fi15=fopen(fname1,"rb");fbyte=getc(fi15);if(feof(fi15)){fclose(fi15);fname1[4]='B';}}else{
	if(fname2[4]=='C'){fname1[4]='B';fi15=fopen(fname1,"rb");fbyte=getc(fi15);if(feof(fi15)){fclose(fi15);fname1[4]='A';}}else{
	if(fname2[4]=='B'){fname1[4]='A';}else{
	}}}}

	if(strlen(fname3)!=0){fi9=fopen(fname3,"wb");fclose(fi9);sf=true;}

	fi15=fopen(fname2,"rb");
	while(!feof(fi15))
	{
		for(i=0;i<nopt;++i){c2[i]='\0';}c2i=0;
		while(!feof(fi15)&&fbyte!=' '){c2[c2i]=fbyte;++c2i;fbyte=getc(fi15);}
		while((int)fbyte!=13&&(int)fbyte!=10&&!feof(fi15)){fbyte=getc(fi15);}
		while(((int)fbyte==10||(int)fbyte==13)&&!feof(fi15)){fbyte=getc(fi15);}
	}
	fclose(fi15);

	fi15=fopen(fname1,"rb");
	
	for(i=0;i<4*nopt;++i){c3[i]='\0';}c3i=0;
	fbyte=getc(fi15);

	while(!feof(fi15))
	{
		for(i=0;i<nopt;++i){c1[i]='\0';}c1i=0;for(i=0;i<nopt;++i){c21[i]='\0';}c21i=0;
		pos1=ftell(fi15);while(!feof(fi15)&&fbyte!=' '){c1[c1i]=fbyte;++c1i;c21[c21i]=fbyte;++c21i;c3[c3i]=fbyte;++c3i;fbyte=getc(fi15);}
		while((int)fbyte!=13&&(int)fbyte!=10&&!feof(fi15)){c3[c3i]=fbyte;++c3i;fbyte=getc(fi15);}
		while((int)fbyte==10||(int)fbyte==13){fbyte=getc(fi15);}
		if(p_comp(c2,c21)==1||p_comp(c2,c21)==strlen(c21))
		{
			fi9=fopen("criteria.txt","wb");
			for(i=0;i<p_strlen(c1);++i){putc(c1[i],fi9);}
			fclose(fi9);
			if(sf){occ+=t1131(1,fname2,false,fname3);}else{occ+=t1131(1,fname2,true,"");}
			break;
		}
		if(!sf){printf("%s\n",c3);}for(i=0;i<4*nopt;++i){c3[i]='\0';}c3i=0;

		if(!feof(fi15))
		{
			pos1=ftell(fi15);	
			c1[c1i]='+';++c1i;for(i=0;i<nopt;++i){c21[i]='\0';}c21i=0;
			while(fbyte!=' '&&!feof(fi15)){c1[c1i]=fbyte;++c1i;c21[c21i]=fbyte;++c21i;c3[c3i]=fbyte;++c3i;fbyte=getc(fi15);}
			while((int)fbyte!=13&&(int)fbyte!=10&&!feof(fi15)){c3[c3i]=fbyte;++c3i;fbyte=getc(fi15);}
			while((int)fbyte==10||(int)fbyte==13){fbyte=getc(fi15);}
			if(p_comp(c2,c21)==1||p_comp(c2,c21)==strlen(c21))
			{
				fi9=fopen("criteria.txt","wb");
				for(i=0;i<p_strlen(c1);++i){putc(c1[i],fi9);}
				fclose(fi9);
				if(sf){occ+=t1131(1,fname2,false,fname3);}else{occ+=t1131(1,fname2,true,"");}
				break;
			}
			if(!sf){printf("%s\n",c3);}for(i=0;i<4*nopt;++i){c3[i]='\0';}c3i=0;
		}

		fi9=fopen("criteria.txt","wb");
		for(i=0;i<p_strlen(c1);++i){putc(c1[i],fi9);}
		fclose(fi9);
		if(sf){occ+=t1131(1,fname2,false,fname3);}else{occ+=t1131(1,fname2,true,"");}
	}
	fclose(fi15);

	return(occ);

}

int p315(char exp[carrl],char fname[nfields][fnamel],int fcount)
{
	int			i,j,k,l,m,n,q,nt,rc=0;
	int			tsp=-1,tep=-1;
	int			rs[128],exc[fnamel];
	int			bsw=0;
	char			ew[fnamel][fnamel];
	char			crita[10][2][fnamel];
	int			critai=0;
	int			occ=0;

	char			cs[carrl];
	char			cs1[carrl];
	char			cs2[carrl];
	char			cs3[carrl];
	int			expp[10];
	int			exppi=0;

	char			*op1="and";
	char			*op2="or";

	bool			df=true;

	//printf("%s\n",exp);
	//for(j=0;j<fcount;++j){printf(" %s\n",fname[j]);}

	exp[strlen(exp)]=' ';
	l=0;for(j=0;j<carrl;++j){cs[j]='\0';}
	for(i=0;i<p_strlen(exp);++i)
	{
		if(exp[i]==' ')
		{
			for(j=0;j<strlen(cs);++j){if(cs[j]=='='||cs[j]=='>'||cs[j]=='<'){break;}}
			if(j!=strlen(cs))
			{	
				for(k=0;k<carrl;++k){cs1[k]='\0';}
				l=0;for(k=0;k<j;++k){cs1[l]=cs[k];++l;}

				for(k=0;k<carrl;++k){cs2[k]='\0';}
				l=0;for(k=j+1;k<strlen(cs);++k){cs2[l]=cs[k];++l;}

				for(k=0;k<strlen(cs2);++k){if(cs2[k]=='"'){break;}}	
				if(k!=strlen(cs2)){l=0;for(k=0;k<carrl;++k){cs[k]='\0';}continue;}

				for(k=0;k<strlen(cs2);++k){if(cs2[k]>='0'&&cs2[k]<='9'){}else{break;}}
				if(k==strlen(cs2)){l=0;for(k=0;k<carrl;++k){cs[k]='\0';}continue;}

				//printf(" %s ",cs1);
				//printf(" %s ",cs2);
				
				for(k=0;k<carrl;++k){cs3[k]='\0';}
				l=0;for(k=0;k<strlen(cs1);++k){cs3[l]=cs1[k];++l;}
				cs3[l]='=';++l;
				for(k=0;k<strlen(cs2);++k){cs3[l]=cs2[k];++l;}

				for(j=0;j<fcount;++j)
				{
					if(1==p_comp(fname[j],cs1)){break;}
				}
				if(j!=fcount)
				{
					if(ref_arr_i==0)
					{
						l=0;for(j=0;j<strlen(cs1);++j){ref_arr[ref_arr_i][0][l]=cs1[j];++l;}
						++ref_arr_i;++rc;
						strcpy(cs3,cs);
						//df=false;
						if(coutfn[4]=='X'){coutfn[4]='A';fi13=fopen(coutfn,"w");fclose(fi13);}else{
						if(coutfn[4]=='A'){coutfn[4]='B';fi13=fopen(coutfn,"w");fclose(fi13);}else{
						if(coutfn[4]=='B'){coutfn[4]='C';fi13=fopen(coutfn,"w");fclose(fi13);}else{
						if(coutfn[4]=='C'){coutfn[4]='D';fi13=fopen(coutfn,"w");fclose(fi13);}else{
						if(coutfn[4]=='D'){coutfn[4]='E';fi13=fopen(coutfn,"w");fclose(fi13);}else{
						}}}}}
					}else{
						for(j=0;j<ref_arr_i;++j)
						{
							if(1==p_comp(cs1,ref_arr[j][0])){break;}
						}
						if(j==ref_arr_i)
						{
							l=0;for(j=0;j<strlen(cs1);++j){ref_arr[ref_arr_i][0][l]=cs1[j];++l;}
							++ref_arr_i;++rc;
							strcpy(cs3,cs);
							//df=false;
							if(coutfn[4]=='X'){coutfn[4]='A';fi13=fopen(coutfn,"w");fclose(fi13);}else{
							if(coutfn[4]=='A'){coutfn[4]='B';fi13=fopen(coutfn,"w");fclose(fi13);}else{
							if(coutfn[4]=='B'){coutfn[4]='C';fi13=fopen(coutfn,"w");fclose(fi13);}else{
							if(coutfn[4]=='C'){coutfn[4]='D';fi13=fopen(coutfn,"w");fclose(fi13);}else{
							if(coutfn[4]=='D'){coutfn[4]='E';fi13=fopen(coutfn,"w");fclose(fi13);}else{
							}}}}}
						}
					}
				}

				for(j=0;j<fcount;++j)
				{
					if(1==p_comp(fname[j],cs2)){break;}
				}
				if(j!=fcount)
				{
					for(j=0;j<ref_arr_i;++j)
					{
						if(1==p_comp(cs1,ref_arr[j][0])){break;}
					}
					if(j!=ref_arr_i)
					{
						l=0;for(k=0;k<strlen(cs2);++k){ref_arr[j][1][l]=cs2[k];++l;}
						strcpy(cs3,cs);++rc;
						//df=false;
						if(coutfn[4]=='X'){coutfn[4]='A';fi13=fopen(coutfn,"w");fclose(fi13);}else{
						if(coutfn[4]=='A'){coutfn[4]='B';fi13=fopen(coutfn,"w");fclose(fi13);}else{
						if(coutfn[4]=='B'){coutfn[4]='C';fi13=fopen(coutfn,"w");fclose(fi13);}else{
						if(coutfn[4]=='C'){coutfn[4]='D';fi13=fopen(coutfn,"w");fclose(fi13);}else{
						if(coutfn[4]=='D'){coutfn[4]='E';fi13=fopen(coutfn,"w");fclose(fi13);}else{
						}}}}}
					}
				}
			}
			l=0;for(j=0;j<carrl;++j){cs[j]='\0';}

		}else{cs[l]=exp[i];++l;}					
	}

	if(rc!=0)
	{

		l=0;for(j=0;j<carrl;++j){cs[j]='\0';}
		for(i=0;i<p_strlen(exp);++i)
		{
			if(exp[i]==' ')
			{
				expp[exppi]=i;++exppi;
				//printf(" %s %s %d\n",cs,cs3,p_comp(cs,cs3));
				if(1==p_comp(cs,cs3)){n=-1+exppi;}
				l=0;for(j=0;j<carrl;++j){cs[j]='\0';}

			}else{cs[l]=exp[i];++l;}					
		}


		for(i=0;i<carrl;++i){cs[i]='\0';}
		if(n>=2)
		{
			l=0;for(i=0;i<expp[n-1-1];++i){cs[l]=exp[i];++l;}
			for(i=expp[n];i<p_strlen(exp);++i){cs[l]=exp[i];++l;}
			for(i=0;i<carrl;++i){exp[i]='\0';}
			for(i=0;i<strlen(cs);++i){exp[i]=cs[i];}
		}else{
			if(n>=0)
			{
				l=0;for(i=expp[n+1];i<p_strlen(exp);++i){cs[l]=exp[i];++l;}
				for(i=0;i<carrl;++i){exp[i]='\0';}
				for(i=0;i<strlen(cs);++i){exp[i]=cs[i];}
			}
		}
	}

	for (i=0;i<10;++i){for (j=0;j<fnamel;++j){crita[i][0][j]='\0';crita[i][1][j]='\0';}}
	for (i=0;i<128;++i){rs[i]=0;}
	for (i=0;i<fnamel;++i){exc[i]=0;}
	for (i=0;i<fnamel;++i){for (j=0;j<fnamel;++j){ew[i][j]='\0';}}

	exp[strlen(exp)]=' ';

	//printf("!!%s %d\n",exp,p_strlen(exp));

	l=0;for(j=0;j<carrl;++j){cs[j]='\0';}
	for(i=0;i<p_strlen(exp);++i)
	{
		if(exp[i]==' '||exp[i]=='='||exp[i]=='>'||exp[i]=='<')
		{
			for(j=0;j<fcount;++j)
			{
				if(1==p_comp(fname[j],cs)){break;}
			}
			if(j!=fcount)
			{
				if(tsp==-1)
				{
					tsp=i-p_strlen(cs);
					for(j=i;j<p_strlen(exp);++j)
					{
						if(exp[j]=='"'&&bsw==0){bsw=1;continue;}
						if(exp[j]==' '&&bsw==0){break;}else{
							if(bsw==1&&exp[j]=='"'){bsw=0;++j;break;}	
						}
					}
					tep=j;
				}else{
					for(j=i;j<p_strlen(exp);++j)
					{
						if(exp[j]=='"'&&bsw==0){bsw=1;continue;}
						if(exp[j]==' '&&bsw==0){break;}else{
							if(bsw==1&&exp[j]=='"'){bsw=0;++j;break;}
						}
					}
					tep=j;
				}
			}else{
				//if(exp[i]=='='||exp[i]=='>'||exp[i]=='<'){
				//
				//	printf("\n!Level 3. Object %s not found\n",cs);
				//	return(0);
				//}
			}
			l=0;for(j=0;j<carrl;++j){cs[j]='\0';}

		}else{cs[l]=exp[i];++l;}					
	}

	for(i=0;i<carrl;++i){cs[i]='\0';}
	l=0;for(i=tsp;i<tep;++i){cs[l]=exp[i];++l;}

	//printf("%s\n",cs);

	for(i=0;i<carrl;++i){exp[i]='\0';}
	l=0;for(i=0;i<strlen(cs);++i){exp[l]=cs[i];++l;}

	l=0;m=0;n=0;
	for(k=l;k<p_strlen(exp);++k)
	{
		if(exp[k]=='"'&&bsw==0){for(i=k;i<-1+p_strlen(exp);++i){exp[i]=exp[i+1];}bsw=1;continue;}
		if(exp[k]==' '&&bsw==0){n=0;for(i=l;i<k;++i){ew[m][n]=exp[i];++n;}++m;l=k+1;}else{
			if(exp[k]=='"'&&bsw==1){n=0;for(i=l;i<k;++i){ew[m][n]=exp[i];++n;}++m;while(exp[i]=='"'||exp[i]==' '){++i;}k=-1+i;l=i;bsw=0;}
		}
	}

	//for (i=0;i<m;++i){printf("+%s+",ew[i]);}

	k=0;l=0;
	for (i=0;i<m-1;++i)
	{
		if (1==p_comp(ew[i],op1)){++k;}
		if (1==p_comp(ew[i],op2)){++l;}
	}
	
	q=0;
	for (i=0;i<m;++i){if (1==p_comp(ew[i],op1)||1==p_comp(ew[i],op2)){/*printf("!%s!\n",ew[i]);*/exc[q]=i-1;++q;}}
	if (q>0){exc[q]=i-1;}else{exc[q]=0;}

	//if (((k>0&&l==0)&&q==1)||(l>0&&k==0)||(l==0&&k==0)){nt=1;}else{nt=2;}
	nt=1;

	if (nt==1)
	{
		if(doutfn[4]!='X')
		{
			df=false;
			if(coutfn[4]=='X'){coutfn[4]='A';fi13=fopen(coutfn,"w");fclose(fi13);}else{
			if(coutfn[4]=='A'){coutfn[4]='B';fi13=fopen(coutfn,"w");fclose(fi13);}else{
			if(coutfn[4]=='B'){coutfn[4]='C';fi13=fopen(coutfn,"w");fclose(fi13);}else{
			if(coutfn[4]=='C'){coutfn[4]='D';fi13=fopen(coutfn,"w");fclose(fi13);}else{
			if(coutfn[4]=='D'){coutfn[4]='E';fi13=fopen(coutfn,"w");fclose(fi13);}else{
			}}}}}
		}

		if(q==0)
		{
			n=0;
			for(l=0;l<p_strlen(ew[exc[n]]);++l){if (ew[exc[n]][l]=='='){j=l+1;break;}}
			if (l<p_strlen(ew[exc[n]]))
			{
				fi9=fopen("criteria.txt","wb");
				for(i=j;i<p_strlen(ew[exc[n]]);++i){putc(ew[exc[n]][i],fi9);}
				fclose(fi9);
				occ=t1131(1,"iinput.txt",df,coutfn);						
			}else{
				for(l=0;l<p_strlen(ew[exc[n]]);++l){if (ew[exc[n]][l]=='>'){j=l+1;break;}}
				if (l<p_strlen(ew[exc[n]]))
				{
					i1131(0);
					fi9=fopen("criteria.txt","wb");
					for(i=j;i<p_strlen(ew[exc[n]]);++i){putc(ew[exc[n]][i],fi9);}
					fclose(fi9);
					occ=t1131(2,"sorted.txt",df,coutfn);						
				}else{
					for(l=0;l<p_strlen(ew[exc[n]]);++l){if (ew[exc[n]][l]=='<'){j=l+1;break;}}
					if (l<p_strlen(ew[exc[n]]))
					{
						i1131(0);
						fi9=fopen("criteria.txt","wb");
						for(i=j;i<p_strlen(ew[exc[n]]);++i){putc(ew[exc[n]][i],fi9);}
						fclose(fi9);
						occ=t1131(3,"sorted.txt",df,coutfn);						
					}
				}
			}
			printf("Total occurences found:%d\n",occ);
			return(0);
		}

		k=0;l=0;
		for (i=0;i<m-1;++i)
		{
			if (1==p_comp(ew[i],op1)){++k;}
			if (1==p_comp(ew[i],op2)){++l;}
		}

		if (l>0)
		{
			for(n=0;n<=q;++n)
			{
				for(l=0;l<p_strlen(ew[exc[n]]);++l){if (ew[exc[n]][l]=='='){j=l+1;break;}}
				if (l<p_strlen(ew[exc[n]]))
				{
					fi9=fopen("criteria.txt","wb");
					for(i=j;i<p_strlen(ew[exc[n]]);++i){putc(ew[exc[n]][i],fi9);}
					fclose(fi9);
					occ=t1131(1,"iinput.txt",df,coutfn);						
				}else{
					for (l=0;l<p_strlen(ew[exc[n]]);++l){if (ew[exc[n]][l]=='>'){j=l+1;break;}}
					if (l<p_strlen(ew[exc[n]]))
					{
						i1131(0);
						fi9=fopen("criteria.txt","wb");
						for(i=j;i<p_strlen(ew[exc[n]]);++i){putc(ew[exc[n]][i],fi9);}
						fclose(fi9);
						occ=t1131(2,"sorted.txt",df,coutfn);
					}else{
						for (l=0;l<p_strlen(ew[exc[n]]);++l){if (ew[exc[n]][l]=='<'){j=l+1;break;}}
						if (l<p_strlen(ew[exc[n]]))
						{
							i1131(0);
							fi9=fopen("criteria.txt","wb");
							for(i=j;i<p_strlen(ew[exc[n]]);++i){putc(ew[exc[n]][i],fi9);}
							fclose(fi9);
							occ=t1131(3,"sorted.txt",df,coutfn);
						}
					}
				}
			}
		}

		k=0;l=0;
		for (i=0;i<m-1;++i)
		{
			if (1==p_comp(ew[i],op1)){++k;}
			if (1==p_comp(ew[i],op2)){++l;}
		}

		if (k>0)
		{				
			for(n=0;n<=q;++n)
			{
				for (l=0;l<p_strlen(ew[exc[n]]);++l){if (ew[exc[n]][l]=='='){j=l+1;crita[critai][1][0]='=';break;}}
				if (l<p_strlen(ew[exc[n]]))
				{
					k=0;for(i=j;i<p_strlen(ew[exc[n]]);++i){crita[critai][0][k]=ew[exc[n]][i];++k;}
					++critai;
				}else{
					for (l=0;l<p_strlen(ew[exc[n]]);++l){if (ew[exc[n]][l]=='>'){j=l+1;crita[critai][1][0]='>';break;}}
					if (l<p_strlen(ew[exc[n]]))
					{
						k=0;for(i=j;i<p_strlen(ew[exc[n]]);++i){crita[critai][0][k]=ew[exc[n]][i];++k;}
						++critai;
					}else{
						for (l=0;l<p_strlen(ew[exc[n]]);++l){if (ew[exc[n]][l]=='<'){j=l+1;crita[critai][1][0]='<';break;}}
						if (l<p_strlen(ew[exc[n]]))
						{
							k=0;for(i=j;i<p_strlen(ew[exc[n]]);++i){crita[critai][0][k]=ew[exc[n]][i];++k;}
							++critai;
						}
					}
				}
			}

			if(critai!=0)
			{					
				i1131(0);
				df=false;
				n=0;
				for(i=0;i<critai;++i)
				{
					if(crita[i][1][0]=='>'&&crita[i+1][1][0]=='<')
					{
						if(doutfn[4]=='X'){doutfn[4]='A';fi13=fopen(doutfn,"w");fclose(fi13);}else{
						if(doutfn[4]=='A'){doutfn[4]='B';fi13=fopen(doutfn,"w");fclose(fi13);}else{
						if(doutfn[4]=='B'){doutfn[4]='C';fi13=fopen(doutfn,"w");fclose(fi13);}else{
						if(doutfn[4]=='C'){doutfn[4]='D';fi13=fopen(doutfn,"w");fclose(fi13);}else{
						if(doutfn[4]=='D'){doutfn[4]='E';fi13=fopen(doutfn,"w");fclose(fi13);}else{
						}}}}}

						fi9=fopen("criteria.txt","wb");
						for(j=0;j<strlen(crita[i][0]);++j){putc(crita[i][0][j],fi9);}
						fclose(fi9);
						occ=t1131(2,"sorted.txt",df,doutfn);

						if(doutfn[4]=='X'){doutfn[4]='A';fi13=fopen(doutfn,"w");fclose(fi13);}else{
						if(doutfn[4]=='A'){doutfn[4]='B';fi13=fopen(doutfn,"w");fclose(fi13);}else{
						if(doutfn[4]=='B'){doutfn[4]='C';fi13=fopen(doutfn,"w");fclose(fi13);}else{
						if(doutfn[4]=='C'){doutfn[4]='D';fi13=fopen(doutfn,"w");fclose(fi13);}else{
						if(doutfn[4]=='D'){doutfn[4]='E';fi13=fopen(doutfn,"w");fclose(fi13);}else{
						}}}}}

						fi9=fopen("criteria.txt","wb");
						for(j=0;j<strlen(crita[i+1][0]);++j){putc(crita[i+1][0][j],fi9);}
						fclose(fi9);
						occ=t1131(3,"sorted.txt",df,doutfn);

						if(coutfn[4]=='X'){coutfn[4]='A';fi13=fopen(coutfn,"w");fclose(fi13);}else{
						if(coutfn[4]=='A'){coutfn[4]='B';fi13=fopen(coutfn,"w");fclose(fi13);}else{
						if(coutfn[4]=='B'){coutfn[4]='C';fi13=fopen(coutfn,"w");fclose(fi13);}else{
						if(coutfn[4]=='C'){coutfn[4]='D';fi13=fopen(coutfn,"w");fclose(fi13);}else{
						if(coutfn[4]=='D'){coutfn[4]='E';fi13=fopen(coutfn,"w");fclose(fi13);}else{
						}}}}}

						occ=p3171(doutfn,coutfn);
						if(ref_arr_i==0){doutfn[4]='X';}

						++i;
						continue;
					}

					fi9=fopen("criteria.txt","wb");
					for(j=0;j<strlen(crita[i][0]);++j){putc(crita[i][0][j],fi9);}
					fclose(fi9);

					if(crita[i][1][0]=='='){++n;continue;}

					if(crita[i][1][0]=='>')
					{
						if(coutfn[4]=='X'){coutfn[4]='A';fi13=fopen(coutfn,"w");fclose(fi13);}else{
						if(coutfn[4]=='A'){coutfn[4]='B';fi13=fopen(coutfn,"w");fclose(fi13);}else{
						if(coutfn[4]=='B'){coutfn[4]='C';fi13=fopen(coutfn,"w");fclose(fi13);}else{
						if(coutfn[4]=='C'){coutfn[4]='D';fi13=fopen(coutfn,"w");fclose(fi13);}else{
						if(coutfn[4]=='D'){coutfn[4]='E';fi13=fopen(coutfn,"w");fclose(fi13);}else{
						}}}}}
						occ=t1131(2,"sorted.txt",df,coutfn);
					}
					if(crita[i][1][0]=='<')
					{
						if(coutfn[4]=='X'){coutfn[4]='A';fi13=fopen(coutfn,"w");fclose(fi13);}else{
						if(coutfn[4]=='A'){coutfn[4]='B';fi13=fopen(coutfn,"w");fclose(fi13);}else{
						if(coutfn[4]=='B'){coutfn[4]='C';fi13=fopen(coutfn,"w");fclose(fi13);}else{
						if(coutfn[4]=='C'){coutfn[4]='D';fi13=fopen(coutfn,"w");fclose(fi13);}else{
						if(coutfn[4]=='D'){coutfn[4]='E';fi13=fopen(coutfn,"w");fclose(fi13);}else{
						}}}}}
						occ=t1131(3,"sorted.txt",df,coutfn);
					}
				}
				if(doutfn[4]=='X')
				{
					if(n>0)
					{
						if(coutfn[4]=='X')
						{
							m=0;
							for(i=0;i<critai;++i)
							{			
								if(crita[i][1][0]=='=')
								{
									++m;
									fi9=fopen("criteria.txt","wb");
									for(j=0;j<strlen(crita[i][0]);++j)
									{
										putc(crita[i][0][j],fi9);
									}
									fclose(fi9);

									if(m==1)
									{
										if(n==1){occ=t1131(1,"sorted.txt",true,"");}else{

											if(doutfn[4]=='X'){doutfn[4]='A';fi13=fopen(doutfn,"w");fclose(fi13);}else{
											if(doutfn[4]=='A'){doutfn[4]='B';fi13=fopen(doutfn,"w");fclose(fi13);}else{
											if(doutfn[4]=='B'){doutfn[4]='C';fi13=fopen(doutfn,"w");fclose(fi13);}else{
											if(doutfn[4]=='C'){doutfn[4]='D';fi13=fopen(doutfn,"w");fclose(fi13);}else{
											if(doutfn[4]=='D'){doutfn[4]='E';fi13=fopen(doutfn,"w");fclose(fi13);}else{
											}}}}}

											occ=t1131(1,"sorted.txt",false,doutfn);
										}
									}else{	
										occ=t1131(1,doutfn,true,"");break;
									}
								}					
							}
						}else{
							m=0;
							for(i=0;i<critai;++i)
							{			
								if(crita[i][1][0]=='=')
								{
									++m;
									fi9=fopen("criteria.txt","wb");
									for(j=0;j<strlen(crita[i][0]);++j)
									{
										putc(crita[i][0][j],fi9);
									}
									fclose(fi9);

									if(m==1)
									{
										if(n==1){occ=t1131(1,coutfn,true,"");}else{

											if(doutfn[4]=='X'){doutfn[4]='A';fi13=fopen(doutfn,"w");fclose(fi13);}else{
											if(doutfn[4]=='A'){doutfn[4]='B';fi13=fopen(doutfn,"w");fclose(fi13);}else{
											if(doutfn[4]=='B'){doutfn[4]='C';fi13=fopen(doutfn,"w");fclose(fi13);}else{
											if(doutfn[4]=='C'){doutfn[4]='D';fi13=fopen(doutfn,"w");fclose(fi13);}else{
											if(doutfn[4]=='D'){doutfn[4]='E';fi13=fopen(doutfn,"w");fclose(fi13);}else{
											}}}}}

											occ=t1131(1,coutfn,false,doutfn);
										}
									}else{	
										occ=t1131(1,doutfn,true,"");break;
									}
								}					
							}
						}
					}else{
						fi9=fopen(coutfn,"rb");	
						while(!feof(fi9)){printf("%c",getc(fi9));}
						fclose(fi9);
					}
				}else{
					if(n>0)
					{
						m=0;
						for(i=0;i<critai;++i)
						{			
							if(crita[i][1][0]=='=')
							{
								++m;
								fi9=fopen("criteria.txt","wb");
								for(j=0;j<strlen(crita[i][0]);++j)
								{
									putc(crita[i][0][j],fi9);
								}
								fclose(fi9);

								if(m==1)
								{
									if(n==1){occ=t1131(1,doutfn,true,"");}else{

										if(coutfn[4]=='X'){coutfn[4]='A';fi13=fopen(coutfn,"w");fclose(fi13);}else{
										if(coutfn[4]=='A'){coutfn[4]='B';fi13=fopen(coutfn,"w");fclose(fi13);}else{
										if(coutfn[4]=='B'){coutfn[4]='C';fi13=fopen(coutfn,"w");fclose(fi13);}else{
										if(coutfn[4]=='C'){coutfn[4]='D';fi13=fopen(coutfn,"w");fclose(fi13);}else{
										if(coutfn[4]=='D'){coutfn[4]='E';fi13=fopen(coutfn,"w");fclose(fi13);}else{
										}}}}}

										occ=t1131(1,doutfn,false,coutfn);
									}
								}else{	
									occ=t1131(1,coutfn,true,"");break;
								}
							}					
						}
					}else{
						fi9=fopen(coutfn,"rb");
						fi13=fopen(doutfn,"w");	
						while(!feof(fi9)){fprintf(fi13,"%c",getc(fi9));}
						fclose(fi9);
						fclose(fi13);
					}
				}
			}
		}

	}

	printf("Total occurences found:%d\n",occ);
}

int p71()
{

	int			k,j,l,i,m,n;
	unsigned		fbyte;
	bool			ex=false,lb=false;

	char			tname1a[tnamel]="db_tables";
	char			tname1b[tnamel]="db_columns";
	
	char			fname1a[fnamel]="db_name";	
	char			fname2a[fnamel]="db_table_name";
	
	char			fname1b[fnamel]="db_table_name";
	char			fname2b[fnamel]="db_field_name";									 
	char			fname3b[fnamel]="db_field_type";

	strcpy(cm,err);

	for(i=0;i<fnamel;++i){for(j=0;j<fnamel;++j){cmkw[i][j]='\0';cmva[i][j]='\0';}}

	cmi=0;
	i=0;j=0;bsw=0;
	while(i<p_strlen(cm))
	{
		l=0;
		for(i=j;i<p_strlen(cm);++i)
		{
			if(cm[i]=='"'&&bsw==0){bsw=1;}else{
			if(cm[i]=='"'&&bsw==1){bsw=0;}}

			if(bsw==0&&(cm[i]>='A'&&cm[i]<='Z')||cm[i]=='*')
			{
				cmkw[cmi][l]=cm[i];++l;
			}else{
				if(cm[i]==' '&&strlen(cmkw[cmi])>0){break;}
			}
		}
		j=i+1;
		++cmi;
	}

	for(k=0;k<fnamel;++k){vor[k][0]=0;vor[k][1]=0;}k=0;

	cmi=0;
	i=0;j=0;bsw=0;
	while(i<p_strlen(cm))
	{
		l=0;
		for(i=j;i<p_strlen(cm);++i)
		{
			if(cm[i]=='"'&&bsw==0){bsw=1;--cmi;l=strlen(cmva[cmi]);}else{
			if(cm[i]=='"'&&bsw==1){bsw=0;cmva[cmi][l]=cm[i];++l;ti=cmi;vor[k][1]=cmi;vor[k][0]=1;++k;break;}}

			if(bsw==0&&((cm[i]>='a'&&cm[i]<='z')||(cm[i]>='0'&&cm[i]<='9')||cm[i]=='_'))
			{
				cmva[cmi][l]=cm[i];++l;
				//vor[k][0]=2;++k;
			}else{
				if(bsw==0&&(cm[i]==' '||cm[i]==','||cm[i]=='<'||cm[i]=='>'||cm[i]=='=')&&strlen(cmva[cmi])>0)
				{
					if(cm[i]!=' '&&cm[i]!=','){cmva[cmi][l]=cm[i];++l;}
					//ti=cmi;
					//vor[k][1]=cmi;
					//vor[k][0]=1;++k;
					break;
				}else{
					if(bsw==1)
					{
						cmva[cmi][l]=cm[i];++l;
						//vor[k][0]=2;++k;
					}
				}
			}
		}
		j=i+1;
		++cmi;
	}


			i=0;
			//printf("\nu1.%s u2.%s u3.%s u4.%s u5.%s u6.%s u7.%s",cmkw[0],cmkw[1],cmkw[2],cmkw[3],cmkw[4],cmkw[5],cmkw[6]);
			//printf("\nl1.%s l2.%s l3.%s l4.%s l5.%s l6.%s l7.%s",cmva[0],cmva[1],cmva[2],cmva[3],cmva[4],cmva[5],cmva[6]);

			if (1==p_comp(cmkw[0],"SELECT")&&cmkw[1][0]=='*')
			{
				if (1==p_comp(cmkw[3],"WHERE"))
				{
					for(i=0;i<fnamel;++i){fname[0][i]=fname1a[i];}
					for(i=0;i<fnamel;++i){fname[1][i]=fname2a[i];}

					strcpy(f11np,f11ns);strcpy(f13np,f13ns);
					if (1<=(i=p313(tname1a,fname,2,fname2a,"=",cmva[0],"",false,false)))
					{
						for(j=0;j<nopt;++j){err[j]='\0';}
						for(j=0;j<fnamel;++j)
						{
							if (p_strlen(cmkw[j])>0)
							{
								if (1==p_comp(cmkw[j],"SELECT"))
								{
									strcat(err,cmkw[j]);
									strcat(err," ");
									strcat(err,v2);
									strcat(err," ");
								}else{
										if (1==p_comp(cmkw[j],"FROM"))
										{
											strcat(err,cmkw[j]);
											strcat(err," ");
											strcat(err,v1);
											strcat(err," ");
										}else{
												if (1==p_comp(cmkw[j],"WHERE"))
												{			
													strcat(err,cmkw[j]);
													strcat(err," ");
													strcat(err,v4);
													strcat(err," ");
												}else{
														strcat(err,cmkw[j]);
														strcat(err," ");
												}
										}
								}
							}else{break;}
						}
						f2=fopen(f2n,"wb");
						fprintf(f2,"%s ",err);
						fclose(f2);

						for(i=0;i<fnamel;++i){fname[0][i]=fname1b[i];}
						for(i=0;i<fnamel;++i){fname[1][i]=fname2b[i];}
						for(i=0;i<fnamel;++i){fname[2][i]=fname3b[i];}

						strcpy(f11np,f11ns);strcpy(f13np,f13ns);
						p313(tname1b,fname,3,fname2b,"=","","out.txt",false,false);

					}else{printf("!Level 0. Object: %s Not Found\n",cmva[0]);return(0);}
				}else{
						for(i=0;i<fnamel;++i){fname[0][i]=fname1a[i];}
						for(i=0;i<fnamel;++i){fname[1][i]=fname2a[i];}

						strcpy(f11np,f11ns);strcpy(f13np,f13ns);
						if (1<=(i=p313(tname1a,fname,2,fname2a,"=",cmva[0],"",false,false)))
						{
							for(j=0;j<nopt;++j){err[j]='\0';}
							for(j=0;j<fnamel;++j)
							{
								if (p_strlen(cmkw[j])>0)
								{
									if (1==p_comp(cmkw[j],"FROM"))
									{
										strcat(err,cmkw[j]);
										strcat(err," ");
										strcat(err,v1);
										strcat(err," ");
									}else{
											strcat(err,cmkw[j]);
											strcat(err," ");
									}
								}else{break;}
							}
							f2=fopen(f2n,"wb");
							fprintf(f2,"%s ",err);
							fclose(f2);

							for(i=0;i<fnamel;++i){fname[0][i]=fname1b[i];}
							for(i=0;i<fnamel;++i){fname[1][i]=fname2b[i];}
							for(i=0;i<fnamel;++i){fname[2][i]=fname3b[i];}

							strcpy(f11np,f11ns);strcpy(f13np,f13ns);
							p313(tname1b,fname,3,fname2b,"=","","out.txt",false,false);

						}else{printf("!Level 0. Object: %s Not Found\n",cmva[0]);return(0);}
				}
			}else{
					if ((1==p_comp(cmkw[0],"SELECT"))&&(1==p_comp(cmkw[1],"FROM"))&&(0==p_comp(cmkw[2],"WHERE")))
					{
						for(i=0;i<fnamel;++i){fname[0][i]=fname1b[i];}
						for(i=0;i<fnamel;++i){fname[1][i]=fname2b[i];}
						for(i=0;i<fnamel;++i){fname[2][i]=fname3b[i];}

						strcpy(f11np,f11ns);strcpy(f13np,f13ns);
						if (1<=(i=p313(tname1b,fname,3,fname2b,"=",cmva[0],"out.txt",false,false)))
						{
							for(j=0;j<nopt;++j){err[j]='\0';}
							for(j=0;j<fnamel;++j)
							{
								if (p_strlen(cmkw[j])>0)
								{
									if (1==p_comp(cmkw[j],"SELECT"))
									{
										strcat(err,cmkw[j]);
										strcat(err," ");
										strcat(err,v2);
										strcat(err," ");
									}else{
											if (1==p_comp(cmkw[j],"FROM"))
											{
												strcat(err,cmkw[j]);
												strcat(err," ");
												strcat(err,v1);
												strcat(err," ");
											}else{
													strcat(err,cmkw[j]);
													strcat(err," ");
											}
									}
								}else{break;}
							}
							printf("!\n");
							f2=fopen(f2n,"wb");
							fprintf(f2,"%s ",err);
							fclose(f2);

							for(i=0;i<fnamel;++i){fname[0][i]=fname1b[i];}
							for(i=0;i<fnamel;++i){fname[1][i]=fname2b[i];}
							for(i=0;i<fnamel;++i){fname[2][i]=fname3b[i];}

							strcpy(f11np,f11ns);strcpy(f13np,f13ns);
							p313(tname1b,fname,3,fname2b,"=","","out.txt",false,false);

						}else{printf("!Level 0. Object: %s Not Found\n",cmva[0]);return(0);}			
					}else{
							if ((1==p_comp(cmkw[0],"SELECT"))&&(1==p_comp(cmkw[1],"FROM"))&&(1==p_comp(cmkw[2],"WHERE")))
							{
								for(i=0;i<fnamel;++i){fname[0][i]=fname1b[i];}
								for(i=0;i<fnamel;++i){fname[1][i]=fname2b[i];}
								for(i=0;i<fnamel;++i){fname[2][i]=fname3b[i];}

								strcpy(f11np,f11ns);strcpy(f13np,f13ns);
								if (1<=(i=p313(tname1b,fname,3,fname2b,"=",cmva[0],"out.txt",false,false)))
								{

									for(j=0;j<nopt;++j){err[j]='\0';}
									for(j=0;j<fnamel;++j)
									{
										if (p_strlen(cmkw[j])>0)
										{
											if (1==p_comp(cmkw[j],"SELECT"))
											{
												strcat(err,cmkw[j]);
												strcat(err," ");
												strcat(err,v2);
												strcat(err," ");
											}else{
													if (1==p_comp(cmkw[j],"FROM"))
													{
														strcat(err,cmkw[j]);
														strcat(err," ");
														strcat(err,v1);
														strcat(err," ");
													}else{
															if (1==p_comp(cmkw[j],"WHERE"))
															{
																strcat(err,cmkw[j]);
																strcat(err," ");
																strcat(err,v4);
																strcat(err," ");
															}else{
																	strcat(err,cmkw[j]);
																	strcat(err," ");
															}
													}
											}
										}else{break;}
									}
									f2=fopen(f2n,"wb");
									fprintf(f2,"%s ",err);
									fclose(f2);

									for(i=0;i<fnamel;++i){fname[0][i]=fname1b[i];}
									for(i=0;i<fnamel;++i){fname[1][i]=fname2b[i];}
									for(i=0;i<fnamel;++i){fname[2][i]=fname3b[i];}

									strcpy(f11np,f11ns);strcpy(f13np,f13ns);
									p313(tname1b,fname,3,fname2b,"=","","out.txt",false,false);

								}else{printf("!Level 0. Object: %s Not Found\n",cmva[0]);return(0);}			
							}
					}
			}

			return(1);
}

void mc915(char fcn2[])
{
	FILE	*fc1,*fc2,*fc21;
	char	fcn1[fnamel]="create.txt";
	char	fcn21[fnamel]="cdata.txt";
	int	i,j,pos;
	char	fbyte,fbyte1;

	char	ls[carrl];
	char	ls1[carrl];

	char	database_name[fnamel];
	char	database_name1[fnamel];
	char	table_name[fnamel];
	char	column_name[fnamel];
	char	la[nfields][3];
	int	ia[nfields];
	int	lai=0;

	char	ts1[fnamel]="create table ";
	char	ts2[fnamel]="create column ";
	char	ts3[fnamel]=" text(";

	char			tname[tnamel]="war_and_peace";	

	unsigned		ftype_i[nfields];
	int			flength_i[nfields];
	char			fname_i[nfields][fnamel];

	unsigned		ftype[nfields];
	int			flength[nfields];
	char			fdata[nfields][fieldlen];	

	for(j=0;j<nfields;++j){ia[j]=0;}

	fc2=fopen(fcn2,"rb");
	fc21=fopen(fcn21,"w");

	fbyte=getc(fc2);

	while(!feof(fc2))
	{
		if((int)fbyte==10||(int)fbyte==13)
		{
			if((int)fbyte1=='\t')
			{
				if((int)fbyte==13)
				{
					fbyte=getc(fc2);
					fprintf(fc21,"\n");

				}else{fprintf(fc21,"\n");}
			}else{
				if((int)fbyte==13)
				{
					fbyte=getc(fc2);
					fprintf(fc21,"\t\n");

				}else{fprintf(fc21,"\t\n");}
			}

		}else{fprintf(fc21,"%c",fbyte);}

		fbyte1=fbyte;fbyte=getc(fc2);	
	}
	fclose(fc2);
	fclose(fc21);

	fc1=fopen(fcn1,"rb");

	fbyte=getc(fc1);
	if(fbyte=='/')
	{
		while(fbyte!=10&&fbyte!=13&&!feof(fc1)){fbyte=getc(fc1);}
		if(fbyte==13){fbyte=getc(fc1);}
		fbyte=getc(fc1);
	}
	
	while(!feof(fc1))
	{
		if(fbyte=='/')
		{
			while(fbyte!=10&&fbyte!=13&&!feof(fc1)){fbyte=getc(fc1);}
			if(fbyte==13){fbyte=getc(fc1);}
		}else{
			for(j=0;j<carrl;++j){ls[j]='\0';}
			i=0;while(fbyte!=10&&fbyte!=13){ls[i]=fbyte;++i;fbyte=getc(fc1);}
			if(fbyte==13){fbyte=getc(fc1);}
			pos=p_comp(ls,ts1);
			if(pos==strlen(ts1))
			{
				for(j=0;j<fnamel;++j){database_name[j]='\0';}
				for(j=0;j<fnamel;++j){table_name[j]='\0';}
				i=0;for(j=pos;j<strlen(ls)&&ls[j]!='.';++j){database_name[i]=ls[j];++i;}
				i=0;for(j=1+pos+strlen(database_name);j<strlen(ls);++j){table_name[i]=ls[j];++i;}
				printf(" %s\n",database_name);
				printf(" %s\n",table_name);


				//------------------------------------------------------------
				strcpy(tname,"db_tables");

				strcpy(fname[0],"db_name");
				strcpy(fname[1],"db_table_name");

				strcpy(fdata[0],database_name);
				strcpy(fdata[1],table_name);

				ftype[0]=1;
				ftype[1]=1;
				ftype[2]=0;

				flength[0]=fnamel;
				flength[1]=fnamel;

				ms915(f11ns,f13ns,2,tname,fname,ftype,flength,fdata);
				//------------------------------------------------------------


			}else{
				pos=p_comp(ls,ts2);
				if(pos==strlen(ts2))
				{
					for(j=0;j<fnamel;++j){table_name[j]='\0';}
					for(j=0;j<fnamel;++j){column_name[j]='\0';}
					i=0;for(j=pos;j<strlen(ls)&&ls[j]!='.';++j){table_name[i]=ls[j];++i;}
					i=0;for(j=1+pos+strlen(table_name);ls[j]!=' ';++j){column_name[i]=ls[j];++i;}

					printf(" %s\n",table_name);
					printf(" %s\n",column_name);


					//------------------------------------------------------------
					strcpy(tname,"db_columns");

					strcpy(fname[0],"db_table_name");
					strcpy(fname[1],"db_field_name");
					strcpy(fname[2],"db_field_type");

					strcpy(fdata[0],table_name);
					strcpy(fdata[1],column_name);
					strcpy(fdata[2],"1");

					ftype[0]=1;
					ftype[1]=1;
					ftype[2]=1;
					ftype[3]=0;

					flength[0]=fnamel;
					flength[1]=fnamel;
					flength[2]=fnamel;

					ms915(f11ns,f13ns,3,tname,fname,ftype,flength,fdata);
					//------------------------------------------------------------
					

					for(j=0;j<carrl;++j){ls1[j]='\0';}
					i=0;for(j=1+pos+strlen(table_name)+strlen(column_name);j<strlen(ls);++j){ls1[i]=ls[j];++i;}

					pos=p_comp(ls1,ts3);
					if(pos==strlen(ts3))
					{
						la[lai][0]='\0';la[lai][1]='\0';la[lai][2]='\0';
						i=0;for(j=pos;ls1[j]!=')';++j){la[lai][i]=ls1[j];++i;}
						ia[lai]=0;
						for(j=0;j<strlen(la[lai]);++j){ia[lai]+=(-48+(int)(la[lai][j]))*pow(10,-1+strlen(la[lai]));}
						printf(" %s %d\n",la[lai],ia[lai]);

						//------------------------------------------------------------
						strcpy(fname_i[lai],column_name);
						ftype_i[lai]=1;
						flength_i[lai]=ia[lai];
						//------------------------------------------------------------
						

						++lai;
					}
				}
			}
		}
		fbyte=getc(fc1);
	}
	fclose(fc1);

	//for(i=0;i<lai;++i)
	//{
	//	printf("%s %d %d\n",fname_i[i],ftype_i[i],flength_i[i]);
	//}

	//--------------------------------------------------------------------------------
	strcpy(tname,table_name);
	ftype_i[lai]=0;
	for(i=0;i<fnamel;++i){database_name1[i]=database_name[i];}

	i=strlen(database_name);
	database_name[i]='_';++i;
	database_name[i]='d';++i;
	database_name[i]='b';++i;
	database_name[i]='_';++i;
	database_name[i]='1';++i;
	database_name[i]='.';++i;
	database_name[i]='m';++i;
	database_name[i]='a';++i;
	database_name[i]='r';++i;

	i=strlen(database_name1);
	database_name1[i]='_';++i;
	database_name1[i]='d';++i;
	database_name1[i]='b';++i;
	database_name1[i]='_';++i;
	database_name1[i]='3';++i;
	database_name1[i]='.';++i;
	database_name1[i]='m';++i;
	database_name1[i]='a';++i;
	database_name1[i]='r';++i;

	mi915(database_name,database_name1,fcn21,3,tname,fname_i,ftype_i,flength_i);
	//--------------------------------------------------------------------------------

}

int p317(char fname2[fnamel])
{
	int	i,j,k,l,m;
	long	pos1;
	long	pos2;
	long 	rrow[10000][2];
	int	rrowi=0;
	char	fname1[fnamel];
	char	fbyte;

	char	c1[nopt];
	int	c1i=0;
	char	c3[nopt];
	int	c3i=0;
	
	strcpy(fname1,fname2);
	
	if(fname2[4]=='E'){fname1[4]='D';fi15=fopen(fname1,"rb");fbyte=getc(fi15);if(feof(fi15)){fclose(fi15);fname1[4]='C';}}else{
	if(fname2[4]=='D'){fname1[4]='C';fi15=fopen(fname1,"rb");fbyte=getc(fi15);if(feof(fi15)){fclose(fi15);fname1[4]='B';}}else{
	if(fname2[4]=='C'){fname1[4]='B';fi15=fopen(fname1,"rb");fbyte=getc(fi15);if(feof(fi15)){fclose(fi15);fname1[4]='A';}}else{
	if(fname2[4]=='B'){fname1[4]='A';}else{
	}}}}

	for(i=0;i<10000;++i){rrow[i][0]=-1;rrow[i][1]=-1;}

	fi15=fopen(fname1,"rb");

	for(i=0;i<nopt;++i){c1[i]='\0';}c1i=0;
	fbyte=getc(fi15);pos1=ftell(fi15);while(!feof(fi15)&&fbyte!=' '){c1[c1i]=fbyte;++c1i;fbyte=getc(fi15);}
	while((int)fbyte!=13&&(int)fbyte!=10&&!feof(fi15)){fbyte=getc(fi15);}
	while((int)fbyte==10||(int)fbyte==13){fbyte=getc(fi15);}

	fi17=fopen(fname2,"rb");

	for(i=0;i<nopt;++i){c3[i]='\0';}c3i=0;
	fbyte=getc(fi17);pos2=ftell(fi17);while(!feof(fi17)&&fbyte!=' '){c3[c3i]=fbyte;++c3i;fbyte=getc(fi17);}
	while((int)fbyte!=13&&(int)fbyte!=10&&!feof(fi17)){fbyte=getc(fi17);}
	while((int)fbyte==10||(int)fbyte==13){fbyte=getc(fi17);}

	while(!feof(fi15))
	{
		while(1==p_comp(c1,c3)&&!feof(fi15)&&!feof(fi17))
		{
			rrow[rrowi][0]=pos1;
			rrow[rrowi][1]=pos2;
			++rrowi;

			for(i=0;i<nopt;++i){c1[i]='\0';}c1i=0;
			pos1=ftell(fi15);while(!feof(fi15)&&fbyte!=' '){c1[c1i]=fbyte;++c1i;fbyte=getc(fi15);}
			while((int)fbyte!=13&&(int)fbyte!=10&&!feof(fi15)){fbyte=getc(fi15);}
			while((int)fbyte==10||(int)fbyte==13){fbyte=getc(fi15);}

			for(i=0;i<nopt;++i){c3[i]='\0';}c3i=0;
			pos2=ftell(fi17);while(!feof(fi17)&&fbyte!=' '){c3[c3i]=fbyte;++c3i;fbyte=getc(fi17);}
			while((int)fbyte!=13&&(int)fbyte!=10&&!feof(fi17)){fbyte=getc(fi17);}
			while((int)fbyte==10||(int)fbyte==13){fbyte=getc(fi17);}
		}

		while(2==p_comp(c1,c3)&&!feof(fi15))
		{
			pos1=ftell(fi15);	
			for(i=0;i<nopt;++i){c1[i]='\0';}c1i=0;
			while(fbyte!=' '&&!feof(fi15)){c1[c1i]=fbyte;++c1i;fbyte=getc(fi15);}
			if(1==p_comp(c1,c3))
			{
				rrow[rrowi][0]=pos1;
				rrow[rrowi][1]=pos2;
				++rrowi;
				while((int)fbyte!=13&&(int)fbyte!=10&&!feof(fi15)){fbyte=getc(fi15);}
				while((int)fbyte==10||(int)fbyte==13){fbyte=getc(fi15);}
			}else{
				while((int)fbyte!=13&&(int)fbyte!=10&&!feof(fi15)){fbyte=getc(fi15);}
				while((int)fbyte==10||(int)fbyte==13){fbyte=getc(fi15);}
			}
		}

		while(3==p_comp(c1,c3)&&!feof(fi17)&&!feof(fi15))
		{
			pos2=ftell(fi17);	
			for(i=0;i<nopt;++i){c3[i]='\0';}c3i=0;
			while(fbyte!=' '&&!feof(fi17)){c3[c3i]=fbyte;++c3i;fbyte=getc(fi17);}
			if(1==p_comp(c1,c3))
			{
				rrow[rrowi][0]=pos1;
				rrow[rrowi][1]=pos2;
				++rrowi;
				while((int)fbyte!=13&&(int)fbyte!=10&&!feof(fi17)){fbyte=getc(fi17);}
				while((int)fbyte==10||(int)fbyte==13){fbyte=getc(fi17);}
			}else{
				while((int)fbyte!=13&&(int)fbyte!=10&&!feof(fi17)){fbyte=getc(fi17);}
				while((int)fbyte==10||(int)fbyte==13){fbyte=getc(fi17);}
			}
		}

		if(feof(fi17)&&!feof(fi15))
		{
			if(3==p_comp(c1,c3)){break;}

			for(i=0;i<nopt;++i){c1[i]='\0';}c1i=0;
			pos1=ftell(fi15);while(!feof(fi15)&&fbyte!=' '){c1[c1i]=fbyte;++c1i;fbyte=getc(fi15);}
			while((int)fbyte!=13&&(int)fbyte!=10&&!feof(fi15)){fbyte=getc(fi15);}
			while((int)fbyte==10||(int)fbyte==13){fbyte=getc(fi15);}


			fclose(fi17);
			fi17=fopen(fname2,"rb");

			for(i=0;i<nopt;++i){c3[i]='\0';}c3i=0;
			pos2=ftell(fi17);while(!feof(fi17)&&fbyte!=' '){c3[c3i]=fbyte;++c3i;fbyte=getc(fi17);}
			while((int)fbyte!=13&&(int)fbyte!=10&&!feof(fi17)){fbyte=getc(fi17);}
			while((int)fbyte==10||(int)fbyte==13){fbyte=getc(fi17);}
		}
	}

	m=0;
	for(i=0;i<rrowi;++i)
	{
		if(rrow[i][0]!=-1&&rrow[i][1]!=-1)
		{
			fseek(fi15,-1+rrow[i][0],SEEK_SET);

			fbyte=getc(fi15);while((int)fbyte!=10&&(int)fbyte!=13){printf("%c",fbyte);fbyte=getc(fi15);}
			printf("\n");

			fseek(fi17,-1+rrow[i][1],SEEK_SET);

			fbyte=getc(fi17);while((int)fbyte!=10&&(int)fbyte!=13){printf("%c",fbyte);fbyte=getc(fi17);}
			printf("\n");
			++m;
		}
	}
	printf("(%d) Rows Retrived\n",m);
	fclose(fi15);
	fclose(fi17);

}

int main(int argc,char *argv[])
{

	char			cmd[255];

	char			pexp[carrl];
	char			ecm[10]="exit";
	char			*nc[10];

	int			i,j,k,l,m,n;
	int			a,b,c;
	unsigned		fbyte;
	bool			ex=false,lb=false;

	char			fdl[fnamel]="";
	char			fnl[fnamel][fnamel],inl[fnamel][fnamel];

	char			ifn01[fnamel]="iinput.txt";
	char			ifn02[fnamel]="out000.txt";
	char			ifn03[fnamel]="out001.txt";
	char			ifn07[fnamel]="out003.txt";

	char			ifn11[fnamel]="iinputA.txt";
	char			ifn12[fnamel]="out000A.txt";
	char			ifn13[fnamel]="out001A.txt";
	char			ifn17[fnamel]="out003A.txt";

	char			ifn21[fnamel]="iinputB.txt";
	char			ifn22[fnamel]="out000B.txt";
	char			ifn23[fnamel]="out001B.txt";
	char			ifn27[fnamel]="out003B.txt";

	//char			tname1a[tnamel]="db_tables";
	//char			tname1b[tnamel]="db_columns";
	
	//char			fname1a[fnamel]="db_name";	
	//char			fname2a[fnamel]="db_table_name";
	
	//char			fname1b[fnamel]="db_table_name";
	//char			fname2b[fnamel]="db_field_name";									 
	//char			fname3b[fnamel]="db_field_type";

	char			tname[tnamel]="war_and_peace";	
	char			tname_arr[tnamel][tnamel];	
	int			tname_i;

	char			tname1a[tnamel]="db_tables";	
	
	char			tname1b[tnamel]="db_columns";	

	char			fname1a[fnamel]="db_name";	
	char			fname2a[fnamel]="db_table_name";

	char			fname1b[fnamel]="db_table_name";
	char			fname2b[fnamel]="db_field_name";									 
	char			fname3b[fnamel]="db_field_type";
	

	char			fdata1a[fieldlen]="sample";
	char			fdata2a[fieldlen]="products_table";

	char			fdata1b[fieldlen]="products_table";
	char			fdata2b[fieldlen]="product_code";
	char			fdata3b[fieldlen]="1";
	char			fdata4b[fieldlen]="product_name";
	char			fdata5b[fieldlen]="1";
	//char			fdata6b[fieldlen]="text_line_3";
	//char			fdata7b[fieldlen]="1";


	//char			fname1[fnamel]="text_line_1";	
	//char			fname2[fnamel]="text_line_2";
	//char			fname3[fnamel]="text_line_3";	
	
	unsigned		ftype[nfields];
	int			flength[nfields];
	char			fdata[nfields][fieldlen];	

	printf("\n\n123SQL Engine Written by Dzinleski Jasenko May,2005\n\n");
	printf("OS Win32 VRM 1.5.0\n\n");






//104971913667479121538554378842519573875903457974667339887685483490550481879481057779790803863504974329894680041989500378245144413017421979151959891707904

	b1[0]=0;	b1[1]=8; 	b1[2]=12; 	b1[3]=26; 	b1[4]=107; 	b1[5]=90; 	b1[6]=13; 	b1[7]=22; 	b1[8]=126; 	b1[9]=3;
	b1[10]=1; 	b1[11]=0; 	b1[12]=0; 	b1[13]=15; 	b1[14]=62; 	b1[15]=20;	b1[16]=26; 	b1[17]=3; 	b1[18]=81; 	b1[19]=3;
	b1[20]=66; 	b1[21]=80; 	b1[22]=3; 	b1[23]=122; 	b1[24]=10; 	b1[25]=125; 	b1[26]=11; 	b1[27]=13; 	b1[28]=22; 	b1[29]=126;
	b1[30]=1; 	b1[31]=0; 	b1[32]=0; 	b1[33]=0; 	b1[34]=12; 	b1[35]=26; 	b1[36]=107; 	b1[37]=59; 	b1[38]=13; 	b1[39]=6;
	b1[40]=126; 	b1[41]=1; 	b1[42]=0; 	b1[43]=0; 	b1[44]=15; 	b1[45]=62; 	b1[46]=4; 	b1[47]=24; 	b1[48]=3; 	b1[49]=65;
	b1[50]=64; 	b1[51]=80; 	b1[52]=63; 	b1[53]=10; 	b1[54]=0; 	b1[55]=0; 	b1[56]=0; 	b1[57]=25; 	b1[58]=119; 	b1[59]=127;
	b1[60]=13; 	b1[61]=22; 	b1[62]=126; 	b1[63]=1;





	
	for(i=1;i<argc;++i)
	{
		if(strlen(argv[i])>0)
		{
			for(j=0;j<255;++j){cmd[j]='\0';}
			strcpy(cmd,argv[i]);

			if(cmd[0]=='-'&&strlen(cmd)==2)
			{
				if(cmd[1]=='d')
				{
					for(j=0;j<fnamel;++j){tname[j]='\0';}
					strcpy(tname,f11n);
					for(j=0;j<fnamel;++j){f11n[j]='\0';}
					strcpy(f11n,argv[i+1]);
					k=0;for(j=strlen(f11n);j<strlen(f11n)+strlen(tname);++j){f11n[j]=tname[k];++k;}
					f11n[j]='\0';

					for(j=0;j<fnamel;++j){tname[j]='\0';}
					strcpy(tname,f13n);
					for(j=0;j<fnamel;++j){f13n[j]='\0';}
					strcpy(f13n,argv[i+1]);
					k=0;for(j=strlen(f13n);j<strlen(f13n)+strlen(tname);++j){f13n[j]=tname[k];++k;}
					f13n[j]='\0';
					
					f1=fopen(f11n,"rb");
					if(f1!=NULL)
					{
						fclose(f1);
					}else{printf("No file!");return(0);}

				}else{
					if(cmd[1]=='c')
					{

						mc915(argv[i+1]);
						return(0);

					}else{
						if(cmd[1]=='h')
						{
							printf("\n\n123SQL Engine Written by Dzinleski Jasenko May,2005\n\n");
							printf("OS Win32 VRM 1.5.0\n\n");
							printf("\n");
							printf("91073 -d <database_name> - To attach a database\n");
							printf("91073 -c <data_import_filename> - To create a database default script filename is create.txt\n");
							printf("\n");
							return(0);
						}else{
							if(cmd[1]=='l'||cmd[1]=='e')
							{	
								printf("\n\n123SQL Engine Written by Dzinleski Jasenko May,2005\n\n");
								printf("OS Win32 VRM 1.5.0\n\n");
								printf("\n");
								printf("\tThis source and sqlengine method apply to GNU General Public License.\n");
								printf("\t		Copyright (C) 2005-2007 Jasenko Dzinleski \n");
								printf("\n");
								printf("\t	This program is free software; you can redistribute it\n");
								printf("\tand/or modify it under the terms of the GNU General Public License as\n");
								printf("\tpublished by the Free Software Foundation; either version 2 of the\n");
								printf("\tLicense, or (at your option) any later version.\n");
								printf("\n");
								printf("\tThis program is distributed in the hope that it will be useful, but\n");
								printf("\tWITHOUT ANY WARRANTY; without even the implied warranty of\n");
								printf("\tMERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU\n");
								printf("\tGeneral Public License for more details.\n");
								printf("\n");
								printf("\tYou should have received a copy of the GNU General Public License along\n");
								printf("\twith this program; if not, write to the Free Software Foundation, Inc.,\n");
								printf("\t51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.\n");
								printf("\n");
								return(0);
							}
						}
					}
				}
			}
		}
	}	

	while(!ex)
	{

		for (i=0;i<nopt;++i){cm[i]='\0';}

		printf("123sql>");gets(cm);
		
		for(l=0;l<p_strlen(cm);++l)
		{
			if (cm[l]!=ecm[l]){break;}
		}

		if (l==strlen(cm)&&strlen(cm)>0){ex=true;}

		if ((!ex)&&strlen(cm)>0)
		{
			f4=fopen(f4n,"wb");
			fprintf(f4,"%s",cm);
			fclose(f4);

			if(1==p9())	{}else{continue;}
			if(1==p71())	{}else{continue;}
			if(1==p_parse()){}else{continue;}
			//continue;

			if (1==p_comp(cmkw[0],"SELECT"))
			{
				for (i=0;i<nfields;++i){for (j=0;j<fnamel;++j){fname[i][j]='\0';}}
					
				if (p_strlen(cmkw[1])==1&&cmkw[1][0]=='*')
				{
					if (1==p_comp(cmkw[2],"FROM")&&strlen(cmkw[3])==0)
					{
						for(j=0;j<tnamel;++j){tname[j]='\0';}
						for(i=0;i<tnamel;++i){for(j=0;j<tnamel;++j){tname_arr[i][j]='\0';}}
						tname_i=0;	

						f15=fopen(f15n,"r");
						for(i=0;i<fnamel;++i)
						{			
							while(!feof(f15))
							{
								fscanf(f15,"%s\n",&fdl);
								if (1==p_comp(cmva[i],fdl))
								{
									if(tname_i==0)
									{
										strcpy(tname,cmva[i]);
										strcpy(tname_arr[tname_i],cmva[i]);
										++tname_i;
										fscanf(f15,"%s\n",&fdl);
										fscanf(f15,"%s\n",&fdl);
										break;
									}else{
	
										for(n=0;n<tname_i;++n)
										{
											if(1==p_comp(cmva[i],tname_arr[n])){break;}
										}

										if(n==tname_i)
										{
											strcpy(tname,cmva[i]);
											strcpy(tname_arr[tname_i],cmva[i]);
											++tname_i;
											fscanf(f15,"%s\n",&fdl);
											fscanf(f15,"%s\n",&fdl);
											break;
										}
									}
								}
								fscanf(f15,"%s\n",&fdl);
								fscanf(f15,"%s\n",&fdl);
							}		
							fclose(f15);
							f15=fopen(f15n,"r");
										
						}
						fclose(f15);
	
						for(n=0;n<tname_i;++n)
						{
							for(j=0;j<nfields;++j){for(i=0;i<fnamel;++i){fname[j][i]='\0';}}
							f15=fopen(f15n,"r");
							i=0;l=0;m=0;
							while(!feof(f15))
							{
								fscanf(f15,"%s\n",&fdl);		

								if (1==p_comp(fdl,tname_arr[n]))
								{
									++i;
									fscanf(f15,"%s\n",&fdl);
									++i;
									for (m=0;strlen(cmva[m])>0;++m)
									{
										if(p_strlen(cmva[m])>0)
										{
											for(j=0;j<fnamel;++j){fname[(i-2)+l][j]=fdl[j];}
											break;
										}
									}
									fscanf(f15,"%s\n",&fdl);
									++i;
									if (i==3){++l;i=0;}
								}else{
										fscanf(f15,"%s\n",&fdl);
										fscanf(f15,"%s\n",&fdl);
								}
							}
							fclose(f15);
							strcpy(f11np,f11n);strcpy(f13np,f13n);
							n=p313(tname_arr[n],fname,l,"","","","",true,false);
						}
					}else{
						if (1==p_comp(cmkw[2],"FROM")&&1==p_comp(cmkw[3],"WHERE"))
						{

							for(j=0;j<tnamel;++j){tname[j]='\0';}
							for(i=0;i<tnamel;++i){for(j=0;j<tnamel;++j){tname_arr[i][j]='\0';}}
							tname_i=0;		

							f15=fopen(f15n,"r");
							for(i=0;i<fnamel;++i)
							{			
								while(!feof(f15))
								{
									fscanf(f15,"%s\n",&fdl);
									if (1==p_comp(cmva[i],fdl))
									{
										if(tname_i==0)
										{
											strcpy(tname,cmva[i]);
											strcpy(tname_arr[tname_i],cmva[i]);
											++tname_i;
											fscanf(f15,"%s\n",&fdl);
											fscanf(f15,"%s\n",&fdl);
											break;
										}else{
		
											for(n=0;n<tname_i;++n)
											{
												if(1==p_comp(cmva[i],tname_arr[n])){break;}
											}

											if(n==tname_i)
											{
												strcpy(tname,cmva[i]);
												strcpy(tname_arr[tname_i],cmva[i]);
												++tname_i;
												fscanf(f15,"%s\n",&fdl);
												fscanf(f15,"%s\n",&fdl);
												break;
											}
										}
									}
									fscanf(f15,"%s\n",&fdl);
									fscanf(f15,"%s\n",&fdl);
								}		
								fclose(f15);
								f15=fopen(f15n,"r");
										
							}
							fclose(f15);
							ref_arr_i=0;
							fi9=fopen(coutfn,"w");
							fclose(fi9);
							coutfn[4]='X';
							doutfn[4]='X';

							for(n=0;n<tname_i;++n)
							{
								for(j=0;j<nfields;++j){for(i=0;i<fnamel;++i){fname[j][i]='\0';}}
								f15=fopen(f15n,"r");
								i=0;l=0;m=0;
								while(!feof(f15))
								{
									fscanf(f15,"%s\n",&fdl);

									if (1==p_comp(fdl,tname_arr[n]))
									{
										++i;
										fscanf(f15,"%s\n",&fdl);
										++i;
										for (m=0;strlen(cmva[m])>0;++m)
										{
											if(p_strlen(cmva[m])>0)
											{
												for(j=0;j<fnamel;++j){fname[(i-2)+l][j]=fdl[j];}
												break;
											}
										}
										fscanf(f15,"%s\n",&fdl);
										++i;
										if (i==3){++l;i=0;}
									}else{
										fscanf(f15,"%s\n",&fdl);
										fscanf(f15,"%s\n",&fdl);
									}
								}
								fclose(f15);

								strcpy(f11np,f11n);strcpy(f13np,f13n);
								p313(tname_arr[n],fname,l,"","","","iinput.txt",true,false);
								m=l;
								for(i=0;i<cmi;++i)
								{												
									if (1==p_comp(cmva[i],tname_arr[-1+tname_i])){j=i;break;}
								}
								l=0;for(i=0;i<carrl;++i){pexp[i]='\0';}

								if(tname_i==1)
								{
									for(i=j+1;i<cmi;++i)
									{
										for(a=0;a<strlen(cmva[i]);++a){pexp[l]=cmva[i][a];++l;}pexp[l]=' ';++l;
									}
								}else{
									for(i=j+1;i<cmi;++i)
									{
										for(k=0;k<fnamel;++k)
										{
											if(strlen(fname[k])==0){continue;}
											b=p_comp(fname[k],cmva[i]);
											if(!(b==2||b==3||b==0))
											{
												if(cmva[-1+i][-1+strlen(cmva[-1+i])]=='=')
												{
													//printf(" %d %s %s%s ",b,fname[k],cmva[-1+i],cmva[i]);

													for(a=0;a<strlen(cmva[-1-1+i]);++a){pexp[l]=cmva[-1-1+i][a];++l;}
													pexp[l]=' ';++l;
													for(a=0;a<strlen(cmva[-1+i]);++a){pexp[l]=cmva[-1+i][a];++l;}
													for(a=0;a<strlen(cmva[i]);++a){pexp[l]=cmva[i][a];++l;}
												}else{
													if(cmva[i][-1+strlen(cmva[i])]=='=')
													{
														//printf(" %d %s %s%s ",b,fname[k],cmva[i],cmva[i+1]);

														for(a=0;a<strlen(cmva[-1+i]);++a){pexp[l]=cmva[-1+i][a];++l;}	
														pexp[l]=' ';++l;
														for(a=0;a<strlen(cmva[i]);++a){pexp[l]=cmva[i][a];++l;}	
														for(a=0;a<strlen(cmva[i+1]);++a){pexp[l]=cmva[i+1][a];++l;}	
													}else{
														//printf(" %d %s %s ",b,fname[k],cmva[i]);
														if(l>0)
														{
															for(a=0;a<strlen(cmva[-1+i]);++a){pexp[l]=cmva[-1+i][a];++l;}	
															pexp[l]=' ';++l;
														}
														for(a=0;a<strlen(cmva[i]);++a){pexp[l]=cmva[i][a];++l;}pexp[l]=' ';++l;	
													}
												}
											}
										}
									}
								}

								if(tname_i>1)
								{
									if(doutfn[4]=='X'){doutfn[4]='A';fi13=fopen(doutfn,"w");fclose(fi13);}else{
									if(doutfn[4]=='A'){doutfn[4]='B';fi13=fopen(doutfn,"w");fclose(fi13);}else{
									if(doutfn[4]=='B'){doutfn[4]='C';fi13=fopen(doutfn,"w");fclose(fi13);}else{
									if(doutfn[4]=='C'){doutfn[4]='D';fi13=fopen(doutfn,"w");fclose(fi13);}else{
									if(doutfn[4]=='D'){doutfn[4]='E';fi13=fopen(doutfn,"w");fclose(fi13);}else{
									}}}}}
								}

								p315(pexp,fname,m);
							}
						}
					}

				}else{
					if (1==p_comp(cmkw[1],"FROM")&&strlen(cmkw[2])==0)
					{
						for(j=0;j<tnamel;++j){tname[j]='\0';}
						for(i=0;i<tnamel;++i){for(j=0;j<tnamel;++j){tname_arr[i][j]='\0';}}
						tname_i=0;

						f15=fopen(f15n,"r");
						for(i=0;i<fnamel;++i)
						{			
							while(!feof(f15))
							{
								fscanf(f15,"%s\n",&fdl);
								if (1==p_comp(cmva[i],fdl))
								{
									if(tname_i==0)
									{
										strcpy(tname,cmva[i]);
										strcpy(tname_arr[tname_i],cmva[i]);
										++tname_i;
										fscanf(f15,"%s\n",&fdl);
										fscanf(f15,"%s\n",&fdl);
										break;
									}else{

										for(n=0;n<tname_i;++n)
										{
											if(1==p_comp(cmva[i],tname_arr[n])){break;}
										}

										if(n==tname_i)
										{
											strcpy(tname,cmva[i]);
											strcpy(tname_arr[tname_i],cmva[i]);
											++tname_i;
											fscanf(f15,"%s\n",&fdl);
											fscanf(f15,"%s\n",&fdl);
											break;
										}
									}
								}
								fscanf(f15,"%s\n",&fdl);
								fscanf(f15,"%s\n",&fdl);
							}		
							fclose(f15);
							f15=fopen(f15n,"r");							
									
						}
						fclose(f15);

						for(n=0;n<tname_i;++n)
						{
							f15=fopen(f15n,"r");
							for(j=0;j<nfields;++j){for(i=0;i<fnamel;++i){fname[j][i]='\0';}}
							i=0;l=0;m=0;
							while(!feof(f15))
							{
								fscanf(f15,"%s\n",&fdl);

								if (1==p_comp(fdl,tname_arr[n]))
								{
									++i;
									fscanf(f15,"%s\n",&fdl);
									++i;
									for (m=0;strlen(cmva[m])>0;++m)
									{
										if(p_strlen(cmva[m])>0)
										{
											if(1==p_comp(cmva[m],fdl))
											{
												for(j=0;j<fnamel;++j){fname[(i-2)+l][j]=fdl[j];}
												break;
											}
										}
									}
									fscanf(f15,"%s\n",&fdl);
									++i;
									if (i==3){++l;i=0;}
								}else{
										fscanf(f15,"%s\n",&fdl);
										fscanf(f15,"%s\n",&fdl);
								}
							}
							fclose(f15);
									
							strcpy(f11np,f11n);strcpy(f13np,f13n);
							p313(tname_arr[n],fname,l,"","","","",true,true);
						}

					}else{
						if (1==p_comp(cmkw[1],"FROM")&&1==p_comp(cmkw[2],"WHERE"))
						{
							for(j=0;j<tnamel;++j){tname[j]='\0';}
							for(i=0;i<tnamel;++i){for(j=0;j<tnamel;++j){tname_arr[i][j]='\0';}}
							tname_i=0;

							f15=fopen(f15n,"r");
							for(i=0;i<fnamel;++i)
							{			
								while(!feof(f15))
								{
									fscanf(f15,"%s\n",&fdl);
									if (1==p_comp(cmva[i],fdl))
									{
										if(tname_i==0)
										{
											strcpy(tname,cmva[i]);
											strcpy(tname_arr[tname_i],cmva[i]);
											++tname_i;
											fscanf(f15,"%s\n",&fdl);
											fscanf(f15,"%s\n",&fdl);
											break;
										}else{
											for(n=0;n<tname_i;++n)
											{
												if(1==p_comp(cmva[i],tname_arr[n])){break;}
											}
											if(n==tname_i)
											{
												strcpy(tname,cmva[i]);
												strcpy(tname_arr[tname_i],cmva[i]);
												++tname_i;
												fscanf(f15,"%s\n",&fdl);
												fscanf(f15,"%s\n",&fdl);
												break;
											}
										}
									}
									fscanf(f15,"%s\n",&fdl);
									fscanf(f15,"%s\n",&fdl);
								}		
								fclose(f15);
								f15=fopen(f15n,"r");							
									
							}
							fclose(f15);
							ref_arr_i=0;
							fi9=fopen(coutfn,"w");
							fclose(fi9);
							coutfn[4]='X';
							doutfn[4]='X';

							for(n=0;n<tname_i;++n)
							{
								f15=fopen(f15n,"r");
								for(j=0;j<nfields;++j){for(i=0;i<fnamel;++i){fname[j][i]='\0';}}
								i=0;l=0;m=0;
								while(!feof(f15))
								{
									fscanf(f15,"%s\n",&fdl);

									if (1==p_comp(fdl,tname_arr[n]))
									{
										++i;
										fscanf(f15,"%s\n",&fdl);
										++i;
										for (m=0;strlen(cmva[m])>0;++m)
										{
											if(p_strlen(cmva[m])>0)
											{
												if(1==p_comp(cmva[m],fdl))
												{
													for(j=0;j<fnamel;++j){fname[(i-2)+l][j]=fdl[j];}
													break;
												}
											}
										}
										fscanf(f15,"%s\n",&fdl);
										++i;
										if (i==3){++l;i=0;}
									}else{
										fscanf(f15,"%s\n",&fdl);
										fscanf(f15,"%s\n",&fdl);
									}
								}
								fclose(f15);

								strcpy(f11np,f11n);strcpy(f13np,f13n);
								p313(tname_arr[n],fname,l,"","","","iinput.txt",true,false);
								m=l;
								for(i=0;i<cmi;++i)
								{												
									if (1==p_comp(cmva[i],tname_arr[-1+tname_i])){j=i;break;}
								}
								l=0;for(i=0;i<carrl;++i){pexp[i]='\0';}

								if(tname_i==1)
								{
									for(i=j+1;i<cmi;++i)
									{
										for(a=0;a<strlen(cmva[i]);++a){pexp[l]=cmva[i][a];++l;}pexp[l]=' ';++l;
									}
								}else{
									for(i=j+1;i<cmi;++i)
									{
										for(k=0;k<fnamel;++k)
										{
											if(strlen(fname[k])==0){continue;}
											b=p_comp(fname[k],cmva[i]);
											if(!(b==2||b==3||b==0))
											{
												if(cmva[-1+i][-1+strlen(cmva[-1+i])]=='=')
												{
													//printf(" %d %s %s%s ",b,fname[k],cmva[-1+i],cmva[i]);

													for(a=0;a<strlen(cmva[-1-1+i]);++a){pexp[l]=cmva[-1-1+i][a];++l;}
													pexp[l]=' ';++l;
													for(a=0;a<strlen(cmva[-1+i]);++a){pexp[l]=cmva[-1+i][a];++l;}
													for(a=0;a<strlen(cmva[i]);++a){pexp[l]=cmva[i][a];++l;}
												}else{
													if(cmva[i][-1+strlen(cmva[i])]=='=')
													{
														//printf(" %d %s %s%s ",b,fname[k],cmva[i],cmva[i+1]);

														for(a=0;a<strlen(cmva[-1+i]);++a){pexp[l]=cmva[-1+i][a];++l;}	
														pexp[l]=' ';++l;
														for(a=0;a<strlen(cmva[i]);++a){pexp[l]=cmva[i][a];++l;}	
														for(a=0;a<strlen(cmva[i+1]);++a){pexp[l]=cmva[i+1][a];++l;}	
													}else{
														//printf(" %d %s %s ",b,fname[k],cmva[i]);
														if(l>0)
														{
															for(a=0;a<strlen(cmva[-1+i]);++a){pexp[l]=cmva[-1+i][a];++l;}	
															pexp[l]=' ';++l;
														}
														for(a=0;a<strlen(cmva[i]);++a){pexp[l]=cmva[i][a];++l;}pexp[l]=' ';++l;	
													}
												}
											}
										}
									}
								}

								if(tname_i>1)
								{
									if(doutfn[4]=='X'){doutfn[4]='A';fi13=fopen(doutfn,"w");fclose(fi13);}else{
									if(doutfn[4]=='A'){doutfn[4]='B';fi13=fopen(doutfn,"w");fclose(fi13);}else{
									if(doutfn[4]=='B'){doutfn[4]='C';fi13=fopen(doutfn,"w");fclose(fi13);}else{
									if(doutfn[4]=='C'){doutfn[4]='D';fi13=fopen(doutfn,"w");fclose(fi13);}else{
									if(doutfn[4]=='D'){doutfn[4]='E';fi13=fopen(doutfn,"w");fclose(fi13);}else{
									}}}}}
								}

								p315(pexp,fname,m);
							}

							if(ref_arr_i>0){occ=p3171(coutfn,"");printf("Total occurences found:%d\n",occ);}
						}
					}
				}
			}					
		}			
	}

	return(0);

}
